# -*- coding: utf-8 -*-
#
# File: Activity.py
#
# Copyright (c) 2007 by []
# Generator: ArchGenXML Version 1.5.0
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """Josef Milota <milota@jcu.cz>"""
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.conference.config import *

# additional imports from tagged value 'import'
from DateTime import DateTime
from Products.CMFCore import CMFCorePermissions
from Products.ATContentTypes.atct import ATCTContent

##code-section module-header #fill in your manual code here
##/code-section module-header

schema = Schema((

    LinesField(
        name='titles',
        default=["en:Activity title","cs:Nazev aktivity"],
        widget=LinesWidget(
            label='Titles',
            label_msgid='conference_label_titles',
            i18n_domain='conference',
        ),
        isMetadata=1,
        searchable=1
    ),

    DateTimeField(
        name='start',
        default=DateTime(),
        widget=CalendarWidget(
            label='Start',
            label_msgid='conference_label_start',
            i18n_domain='conference',
        ),
        languageIndependent=1
    ),

    DateTimeField(
        name='end',
        default=DateTime(),
        widget=CalendarWidget(
            label='End',
            label_msgid='conference_label_end',
            i18n_domain='conference',
        ),
        languageIndependent=1
    ),

    StringField(
        name='location',
        widget=StringWidget(
            label='Location',
            label_msgid='conference_label_location',
            i18n_domain='conference',
        ),
        languageIndependent=1
    ),

    TextField(
        name='description',
        allowable_content_types=('text/plain'),
        widget=TextAreaWidget(
            label='Description',
            label_msgid='conference_label_description',
            i18n_domain='conference',
        )
    ),

    FloatField(
        name='price',
        default=0.0,
        widget=DecimalWidget(
            label='Price',
            label_msgid='conference_label_price',
            i18n_domain='conference',
        )
    ),

    FloatField(
        name='vat',
        widget=DecimalWidget(
            label='Vat',
            label_msgid='conference_label_vat',
            i18n_domain='conference',
        ),
        default_method="getDefaultVat"
    ),

    BooleanField(
        name='subtractvat',
        default=0,
        widget=BooleanWidget(
            label='Subtractvat',
            label_msgid='conference_label_subtractvat',
            i18n_domain='conference',
        ),
        languageIndependent=1
    ),

    IntegerField(
        name='capacity',
        default=0,
        widget=IntegerWidget(
            label='Capacity',
            label_msgid='conference_label_capacity',
            i18n_domain='conference',
        ),
        languageIndependent=1
    ),

    IntegerField(
        name='activitytype',
        widget=SelectionWidget
        (
            label='Activitytype',
            label_msgid='conference_label_activitytype',
            i18n_domain='conference',
        ),
        languageIndependent=1,
        multiValued=0,
        vocabulary='getActivityTypesVoc',
        default=0,
        accessor="getActivitytype"
    ),

    BooleanField(
        name='mandatory',
        default=0,
        widget=BooleanWidget(
            label='Mandatory',
            label_msgid='conference_label_mandatory',
            i18n_domain='conference',
        ),
        languageIndependent=1
    ),

    BooleanField(
        name='freeforcommittee',
        default=0,
        widget=BooleanWidget(
            label='Freeforcommittee',
            label_msgid='conference_label_freeforcommittee',
            i18n_domain='conference',
        ),
        languageIndependent=1
    ),

    ComputedField(
        name='utilizedcapacity',
        widget=ComputedWidget(
            label='Utilizedcapacity',
            label_msgid='conference_label_utilizedcapacity',
            i18n_domain='conference',
        ),
        languageIndependent=1,
        expression="context.getUtilizedCapacity"
    ),

    DateTimeField(
        name='deadline',
        widget=CalendarWidget(
            label='Deadline',
            label_msgid='conference_label_deadline',
            i18n_domain='conference',
        ),
        languageIndependent=1
    ),

    BooleanField(
        name='isoffered',
        default=1,
        widget=BooleanWidget(
            label='Isoffered',
            label_msgid='conference_label_isoffered',
            i18n_domain='conference',
        ),
        languageIndependent=1
    ),

    ComputedField(
        name='title',
        widget=ComputedWidget(
            visible={'edit':'invisible','view':'visible'},
            label='Title',
            label_msgid='conference_label_title',
            i18n_domain='conference',
        ),
        expression="context.Title()",
        accessor="Title",
        searchable=1
    ),

    ComputedField(
        name='articles',
        widget=ComputedWidget(
            label='Articles',
            label_msgid='conference_label_articles',
            i18n_domain='conference',
        )
    ),

),
)

##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

Activity_schema = BaseSchema.copy() + \
    schema.copy()

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class Activity(BaseContent):
    """
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseContent,'__implements__',()),)

    # This name appears in the 'add' box
    archetype_name = 'Activity'

    meta_type = 'Activity'
    portal_type = 'Activity'
    allowed_content_types = []
    filter_content_types = 0
    global_allow = 0
    content_icon = 'arrowRight.gif'
    immediate_view = 'activity_view'
    default_view = 'activity_view'
    suppl_views = ()
    typeDescription = "Activity"
    typeDescMsgId = 'description_edit_activity'


    actions =  (


       {'action': "string:${object_url}/activity_view",
        'category': "object",
        'id': 'view',
        'name': 'View',
        'permissions': ("View",),
        'condition': 'python:1'
       },


    )

    _at_rename_after_creation = True

    schema = Activity_schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header

    # Methods

    security.declarePublic('getActivityTypesVoc')
    def getActivityTypesVoc(self):
        """

        """

        ats = self.getConfObject().getActivityTypes()
        voc = zip(range(len(ats)),ats)
        return voc

    security.declarePublic('getUtilizedCapacity')
    def getUtilizedCapacity(self):
        """

        """
        conf = self.getConfObject()
        participants = len(conf.Participants.objectValues(['Conferee']))
        committees = len(conf.OrgCommittee.objectValues(['Conferee'])) + len(conf.ProgCommittee.objectValues(['Conferee']))
        actbackrefs = len(self.getBRefs(relationship='activities'))
        committeesbackrefs = len([x for x in self.getBRefs(relationship='activities') if x.aq_parent.getId() in ['OrgCommittee','ProgCommittee']])
        if self.getMandatory():
            if self.getFreeforcommittee():
                return participants
            else:
                return participants + committees
        else:
            if self.getFreeforcommittee():
                return actbackrefs - committeesbackrefs
            else:
                return actbackrefs

        len(context.getBRefs(relationship='activities'))

    security.declarePublic('Title')
    def Title(self):
        """

        """

        tit = {}
        if self.getTitles():
            for t in self.getTitles():
                if len(t)>2:
                    tit[t[:2]] = t[3:]
        if hasattr(self,'portal_languages'):
            prefLang = self.portal_languages.getLanguageBindings()[0]
        else:
            prefLang = 'en'
        if tit.has_key(prefLang):
            l = prefLang
        else:
            if tit:
                l = tit.keys()[0]
            else:
                l = ''
        if l:
            return tit[l]
        else:
            return 'Activity'

    security.declarePublic('Description')
    def Description(self):
        """

        """

        return self.getDescription()

    security.declarePublic('getActivitytype')
    def getActivitytype(self):
        """

        """

        v = self.getConfObject().getActivityTypes()
        a = self.activitytype
        if self.REQUEST.URL.split('/')[-1] in ['base_edit','edit']:
            return a
        else:
            if len(v)>0:
                return v[a]
            else:
                return ''

    security.declarePublic('getArticles')
    def getArticles(self):
        """

        """

        acts = self.getBRefs(relationship='activity')
        out = [x for x in acts if self.portal_membership.getAuthenticatedMember().has_permission("View",x)]
        return out

    security.declarePublic('getDefaultVat')
    def getDefaultVat(self):
        """

        """

        return self.getConfObject().getDefaultvat()


registerType(Activity, PROJECTNAME)
# end of class Activity

##code-section module-footer #fill in your manual code here
##/code-section module-footer



