# -*- coding: utf-8 -*-
#
# File: Article.py
#
# Copyright (c) 2007 by []
# Generator: ArchGenXML Version 1.5.0
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """Josef Milota <milota@jcu.cz>"""
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.conference.config import *

# additional imports from tagged value 'import'
from Products.ATReferenceBrowserWidget.ATReferenceBrowserWidget import *

##code-section module-header #fill in your manual code here
##/code-section module-header

schema = Schema((

    StringField(
        name='author1lastname',
        widget=StringWidget(
            visible={'edit':'visible','view':'invisible'},
            label="First author's last name",
            description="Fill in the last name of the first author of this article",
            label_msgid='conference_label_author1lastname',
            description_msgid='conference_help_author1lastname',
            i18n_domain='conference',
        ),
        required=1,
        default_method="getDefaultauthor1lastname"
    ),

    StringField(
        name='author1firstname',
        widget=StringWidget(
            visible={'edit':'visible','view':'invisible'},
            label="First author's first name",
            description="Fill in the first name of the first author of this article",
            label_msgid='conference_label_author1firstname',
            description_msgid='conference_help_author1firstname',
            i18n_domain='conference',
        ),
        required=1,
        default_method="getDefaultauthor1firstname"
    ),

    StringField(
        name='author2lastname',
        widget=StringWidget(
            visible={'edit':'visible','view':'invisible'},
            label="Second author's last name",
            description="Fill in the last name of the second author of this article",
            label_msgid='conference_label_author2lastname',
            description_msgid='conference_help_author2lastname',
            i18n_domain='conference',
        )
    ),

    StringField(
        name='author2firstname',
        widget=StringWidget(
            visible={'edit':'visible','view':'invisible'},
            label="Second author's first name",
            description="Fill in the first name of the second author of this article",
            label_msgid='conference_label_author2firstname',
            description_msgid='conference_help_author2firstname',
            i18n_domain='conference',
        )
    ),

    StringField(
        name='author3lastname',
        widget=StringWidget(
            visible={'edit':'visible','view':'invisible'},
            label="Third author's last name",
            description="Fill in the last name of the third author of this article",
            label_msgid='conference_label_author3lastname',
            description_msgid='conference_help_author3lastname',
            i18n_domain='conference',
        )
    ),

    StringField(
        name='author3firstname',
        widget=StringWidget(
            visible={'edit':'visible','view':'invisible'},
            label="Third author's first name",
            description="Fill in the first name of the third author of this article",
            label_msgid='conference_label_author3firstname',
            description_msgid='conference_help_author3firstname',
            i18n_domain='conference',
        )
    ),

    #Are there more authors yet?
    #
    #If so, the text like "et al." will be displayed in the authors
    #list.
    BooleanField(
        name='otherauthors',
        default=0,
        widget=BooleanWidget(
            visible={'edit':'visible','view':'invisible'},
            label="Other authors",
            description="If there are other authors than those listed above, check this field",
            label_msgid='conference_label_otherauthors',
            description_msgid='conference_help_otherauthors',
            i18n_domain='conference',
        ),
        author="David Mudrak"
    ),

    IntegerField(
        name='articleform',
        mutator="setArticleform",
        widget=SelectionWidget
        (
            label="Article form",
            description="Choose the form of your contribution",
            label_msgid='conference_label_articleform',
            description_msgid='conference_help_articleform',
            i18n_domain='conference',
        ),
        required=1,
        multiValued=0,
        vocabulary='getArticleformVoc',
        default=0,
        enforceVocabulary=1,
        accessor="getArticleform"
    ),

    StringField(
        name='titleorig',
        widget=StringWidget(
            size="80",
            visible={'edit':'visible','view':'invisible'},
            label="Title of the article",
            description="Fill in the title of this article",
            label_msgid='conference_label_titleorig',
            description_msgid='conference_help_titleorig',
            i18n_domain='conference',
        ),
        required=1,
        searchable=1
    ),

    StringField(
        name='titleeng',
        widget=StringWidget(
            size="80",
            visible={'edit':'invisible','view':'invisible'},
            label="Title of the article in English",
            label_msgid='conference_label_titleeng',
            i18n_domain='conference',
        ),
        required=0,
        searchable=1
    ),

    TextField(
        name='abstractorig',
        allowable_content_types=('text/plain','text/html'),
        widget=RichWidget
        (
            label='Abstractorig',
            label_msgid='conference_label_abstractorig',
            i18n_domain='conference',
        ),
        default_output_type='text/html',
        searchable=1,
        required=1
    ),

    TextField(
        name='abstracteng',
        allowable_content_types=('text/plain','text/html'),
        widget=RichWidget
        (
            visible={'edit':'invisible','view':'invisible'},
            label='Abstracteng',
            label_msgid='conference_label_abstracteng',
            i18n_domain='conference',
        ),
        default_output_type='text/html',
        searchable=1,
        required=0
    ),

    IntegerField(
        name='topic',
        default=0,
        widget=SelectionWidget
        (
            label='Topic',
            label_msgid='conference_label_topic',
            i18n_domain='conference',
        ),
        multiValued=0,
        vocabulary='getTopicsVoc'
    ),

    LinesField(
        name='keywords',
        widget=LinesWidget(
            description="Please insert up to three keywords or key concepts describing your work. Put each keyword on a separate line.",
            label='Keywords',
            label_msgid='conference_label_keywords',
            description_msgid='conference_help_keywords',
            i18n_domain='conference',
        ),
        searchable=1
    ),

    FileField(
        name='reviewversion',
        widget=FileWidget(
            macro="file_widget_macro",
            description="Upload the draft of your article. This version does not need to be camera-ready yet. It will be reviewed by conference reviewers.",
            label='Reviewversion',
            label_msgid='conference_label_reviewversion',
            description_msgid='conference_help_reviewversion',
            i18n_domain='conference',
        ),
        storage=AttributeStorage(),
        read_permission="conference: View article review version",
        write_permission="conference: View article review version"
    ),

    ComputedField(
        name='review',
        widget=ComputedWidget(
            label='Review',
            label_msgid='conference_label_review',
            i18n_domain='conference',
        ),
        expression="context.getReview()",
        read_permission="conference: View article review version",
        write_permission="conference: View article review version"
    ),

    FileField(
        name='finalversion',
        widget=FileWidget(
            macro="file_widget_macro",
            description="Upload the camera-ready version of your reviewed article",
            label='Finalversion',
            label_msgid='conference_label_finalversion',
            description_msgid='conference_help_finalversion',
            i18n_domain='conference',
        ),
        storage=AttributeStorage(),
        read_permission="conference: View article final version",
        write_permission="conference: View article final version"
    ),

    FileField(
        name='file1',
        widget=FileWidget(
            macro="file_widget_macro",
            visible={'edit':'invisible','view':'invisible'},
            label='File1',
            label_msgid='conference_label_file1',
            i18n_domain='conference',
        ),
        storage=AttributeStorage()
    ),

    IntegerField(
        name='expertisemaj',
        default=0,
        widget=SelectionWidget
        (
            description="Choose an appropriate major expertise.",
            label='Expertisemaj',
            label_msgid='conference_label_expertisemaj',
            description_msgid='conference_help_expertisemaj',
            i18n_domain='conference',
        ),
        accessor="getExpertisemaj",
        vocabulary='getExpertisesVoc'
    ),

    IntegerField(
        name='expertisemin',
        default=0,
        widget=SelectionWidget
        (
            description="Choose an appropriate minor topic",
            label='Expertisemin',
            label_msgid='conference_label_expertisemin',
            description_msgid='conference_help_expertisemin',
            i18n_domain='conference',
        ),
        accessor="getExpertisemin",
        vocabulary='getExpertisesVoc'
    ),

    ComputedField(
        name='title',
        widget=ComputedWidget(
            visible={'edit':'invisible','view':'invisible'},
            label='Title',
            label_msgid='conference_label_title',
            i18n_domain='conference',
        ),
        expression="context.Title()"
    ),

    StringField(
        name='order',
        default='',
        widget=StringWidget(
            label='Order',
            label_msgid='conference_label_order',
            i18n_domain='conference',
        ),
        write_permission="conference: Manage content"
    ),

    ReferenceField(
        name='activity',
        widget=ReferenceBrowserWidget
        (
            startup_directory="../../Activities",
            label='Activity',
            label_msgid='conference_label_activity',
            i18n_domain='conference',
        ),
        allowed_types=('Activity',),
        multiValued=0,
        relationship='activity',
        write_permission="conference: Manage content"
    ),

),
)

##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

Article_schema = BaseSchema.copy() + \
    schema.copy()

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class Article(BaseContent):
    """
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseContent,'__implements__',()),)

    # This name appears in the 'add' box
    archetype_name = 'Article'

    meta_type = 'Article'
    portal_type = 'Article'
    allowed_content_types = []
    filter_content_types = 0
    global_allow = 0
    content_icon = 'document_icon.gif'
    immediate_view = 'base_view'
    default_view = 'base_view'
    suppl_views = ()
    typeDescription = "This document contains all your article details. You control the workflow of your article by changing the state of this document."
    typeDescMsgId = 'description_edit_article'


    actions =  (


       {'action': "string:${object_url}/add_review_for_context",
        'category': "object",
        'id': 'create_review',
        'name': 'create_review',
        'permissions': ("View",),
        'condition': 'python:object.portal_membership.getAuthenticatedMember().has_permission("Modify portal content",object) and object.getConfObject().isReviewsManager()'
       },


    )

    _at_rename_after_creation = True

    schema = Article_schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header

    # Methods

    security.declarePublic('getExpertisesVoc')
    def getExpertisesVoc(self):
        """

        """

        ats = self.getConfObject().getExperTises()
        voc = zip(range(len(ats)),ats)
        return voc

    security.declarePublic('getExpertisemaj')
    def getExpertisemaj(self):
        """

        """

        v = self.getConfObject().getExperTises()
        a = self.expertisemaj
        if self.REQUEST.URL.split('/')[-1] in ['base_edit','edit']:
            return a
        else:
            if len(v)>0:
                return v[a]
            else:
                return ''

    security.declarePublic('getExpertisemin')
    def getExpertisemin(self):
        """

        """

        v = self.getConfObject().getExperTises()
        a = self.expertisemin
        if self.REQUEST.URL.split('/')[-1] in ['base_edit','edit']:
            return a
        else:
            if len(v)>0:
                return v[a]
            else:
                return ''

    security.declarePublic('Title')
    def Title(self):
        """

        """
        return self.getAuthors() + ': ' + self.getTitleorig()

    security.declarePublic('getReview')
    def getReview(self):
        """

        """

        out = '<ul>\n'
        revs = self.getBRefs(relationship='article')
        for a in revs:
            f = a.review
            r = a.getReviewer()
            if r and self.portal_membership.getAuthenticatedMember().has_role(['Manager'],self):
                reviewer = '(<a href="%s" class="Reviewer">%s</a>)' % (r.absolute_url(),r.Title())
            else:
                reviewer = ''
            if f.get_size() > 0:
                reviewstr = '<li><a href="%s/at_download/review" class="Article">%s</a> %s\n</li>\n' \
                      % (a.absolute_url(),a.title_or_id(),reviewer)
            else:
                reviewstr = '<li>%s %s\n</li>\n' % (a.title_or_id(),reviewer)
            out += reviewstr
        out += '</ul>\n'
        return out

    security.declarePublic('getArticleformVoc')
    def getArticleformVoc(self):
        """

        """

        afs = self.getConfObject().getArticleForms()
        voc = zip(range(len(afs)),afs)
        return voc

    security.declarePublic('getArticleform')
    def getArticleform(self):
        """

        """

        v = self.getConfObject().getArticleForms()
        a = self.articleform
        if self.REQUEST.URL.split('/')[-1] in ['base_edit','edit']:
            return a
        else:
            if len(v)>0:
                return v[a]
            else:
                return ''

    security.declarePublic('getDefaultauthor1lastname')
    def getDefaultauthor1lastname(self):
        """
        Return the default Author1's lastname.

        Usually, author1 is the authenticated user. Thus return her
        lastname.
        """
        user = self.portal_membership.getAuthenticatedMember()
        if hasattr(user, 'getLastname'):
            return user.getLastname()
        else:
            return ''

    security.declarePublic('getDefaultauthor1firstname')
    def getDefaultauthor1firstname(self):
        """
        Return the default Author1's firstname.

        Usually, author1 is the authenticated user. Thus return her
        firstname.
        """
        user = self.portal_membership.getAuthenticatedMember()
        if hasattr(user, 'getFirstname'):
            return user.getFirstname()
        else:
            return ''

    security.declarePublic('getAuthors')
    def getAuthors(self):
        """
        Return formated string containing all authors.

        There is a lot of citation forms. We use simple form:
        LASTNAME1, F., LASTNAME2, F. et al.

        TODO: Create a customizable script in skins that will take care of this, so an site-admin may
              modify the form easily.
        """
        charset = self.portal_properties.site_properties.getProperty('default_charset', 'utf-8')
        if self.getAuthor1lastname() and self.getAuthor1firstname():
            authors = "%s, %s." % (self.getAuthor1lastname().decode(charset).upper().encode(charset), self.getAuthor1firstname()[0])
            if self.getAuthor2lastname() and self.getAuthor2firstname():
                authors = "%s, %s, %s." % (authors, self.getAuthor2lastname().decode(charset).upper().encode(charset), self.getAuthor2firstname()[0])
            if self.getAuthor3lastname() and self.getAuthor3firstname():
                authors = "%s, %s, %s." % (authors, self.getAuthor3lastname().decode(charset).upper().encode(charset), self.getAuthor3firstname()[0])
            if self.getOtherauthors():
                authors = "%s et al." % (authors)
        else:
            authors = "Unknown"
        return authors

    security.declarePublic('getTopicsVoc')
    def getTopicsVoc(self):
        """
        """
        ats = self.getConfObject().getLocalizedTopics()
        voc = zip(range(len(ats)),ats)
        return voc

    security.declarePublic('getTopic')
    def getTopic(self):
        """
        """
        v = self.getConfObject().getLocalizedTopics()
        a = getattr(self, 'topic', None)
        try:
            a = int(a)
        except TypeError:
            return ''
        try:
            return v[a]
        except:
            return ''

    security.declarePublic('getRawTopic')
    def getRawTopic(self):
        """
        This is my own edit_accessor for the field topic.
        """
        a = getattr(self, 'topic', None)
        try:
            a = int(a)
            return a
        except TypeError:
            return ''


registerType(Article, PROJECTNAME)
# end of class Article

##code-section module-footer #fill in your manual code here
##/code-section module-footer



