# -*- coding: utf-8 -*-
#
# File: Conferee.py
#
# Copyright (c) 2007 by []
# Generator: ArchGenXML Version 1.5.0
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """Josef Milota <milota@jcu.cz>"""
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.conference.config import *

# additional imports from tagged value 'import'
from Products.ATReferenceBrowserWidget.ATReferenceBrowserWidget import *
from Products.CMFCore import CMFCorePermissions

##code-section module-header #fill in your manual code here
##/code-section module-header

schema = Schema((

    ComputedField(
        name='payment',
        widget=ComputedWidget(
            label='Payment',
            label_msgid='conference_label_payment',
            i18n_domain='conference',
        ),
        expression="context.getMyPayment()[0]",
        read_permission="Modify portal content"
    ),

    StringField(
        name='varnumber',
        widget=StringWidget(
            label='Varnumber',
            label_msgid='conference_label_varnumber',
            i18n_domain='conference',
        ),
        default_method="getNewVarnumber",
        read_permission="Modify portal content",
        mode="r"
    ),

    StringField(
        name='id',
        widget=StringWidget(
            visible={'edit':'hidden', 'view':'hidden'},
            label='Id',
            label_msgid='conference_label_id',
            i18n_domain='conference',
        )
    ),

    ComputedField(
        name='title',
        widget=ComputedWidget(
            label='Title',
            label_msgid='conference_label_title',
            i18n_domain='conference',
        ),
        expression="context.getMyFullname()",
        accessor="Title",
        searchable=1
    ),

    FloatField(
        name='paid',
        default=0.0,
        widget=DecimalWidget(
            label='Paid',
            label_msgid='conference_label_paid',
            i18n_domain='conference',
        ),
        read_permission="Modify portal content",
        write_permission="conference: Edit content"
    ),

    DateTimeField(
        name='paiddate',
        widget=CalendarWidget(
            label='Paiddate',
            label_msgid='conference_label_paiddate',
            i18n_domain='conference',
        ),
        read_permission="Modify portal content",
        write_permission="conference: Edit content"
    ),

    BooleanField(
        name='novat',
        default=0,
        widget=BooleanWidget(
            label='Novat',
            label_msgid='conference_label_novat',
            i18n_domain='conference',
        ),
        read_permission="Modify portal content",
        write_permission="conference: Edit content"
    ),

    BooleanField(
        name='nopayment',
        default=0,
        widget=BooleanWidget(
            label='Nopayment',
            label_msgid='conference_label_nopayment',
            i18n_domain='conference',
        ),
        read_permission="Modify portal content",
        write_permission="conference: Edit content"
    ),

    ReferenceField(
        name='userid',
        widget=ReferenceBrowserWidget
        (
            startup_directory="/portal_memberdata",
            label='Userid',
            label_msgid='conference_label_userid',
            i18n_domain='conference',
        ),
        required=1,
        multiValued=0,
        relationship='userid',
        allowed_types=('ConfMember',),
        write_permission="conference: Edit content"
    ),

    ReferenceField(
        name='activities',
        widget=ReferenceBrowserWidget
        (
            format="checkbox",
            startup_directory="../../Activities",
            label='Activities',
            label_msgid='conference_label_activities',
            i18n_domain='conference',
        ),
        multiValued=1,
        relationship='activities',
        allowed_types=('Activity',),
        write_permission="conference: Edit content",
        read_permission="Modify portal content"
    ),

),
)

##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

Conferee_schema = BaseSchema.copy() + \
    schema.copy()

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class Conferee(BaseContent):
    """
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseContent,'__implements__',()),)

    # This name appears in the 'add' box
    archetype_name = 'Conferee'

    meta_type = 'Conferee'
    portal_type = 'Conferee'
    allowed_content_types = []
    filter_content_types = 0
    global_allow = 0
    content_icon = 'user.gif'
    immediate_view = 'base_view'
    default_view = 'base_view'
    suppl_views = ()
    typeDescription = "Conferee"
    typeDescMsgId = 'description_edit_conferee'


    actions =  (


       {'action': "string:${object_url}/conferee_view",
        'category': "object",
        'id': 'view',
        'name': 'View',
        'permissions': ("View",),
        'condition': 'python:1'
       },


       {'action': "string:${object_url}/base_edit",
        'category': "object",
        'id': 'edit',
        'name': 'Edit',
        'permissions': ("conference: Edit content",),
        'condition': 'python:1'
       },


    )

    _at_rename_after_creation = True

    schema = Conferee_schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header

    # Methods

    security.declarePublic('getNewVarnumber')
    def getNewVarnumber(self):
        """

        """

        n = 0
        conf = self.aq_parent.aq_parent
        prefix = conf.getBanknumberprefix()
        for y in ['Participants','OrgCommittee','ProgCommittee']:
            for x in conf[y].objectValues(['Conferee']):
                if self.getId() != x.getId():
                    if int(x.getVarnumber()[-4:])>n:
                        n = int(x.getVarnumber()[-4:])
        return '%s%04d' % (prefix,n+1)

    security.declarePublic('getMyPayment')
    def getMyPayment(self):
        """

        """

        s = 0.0
        act = []
        if self.getUserid():
            conf = self.getConfObject()
            utool = self.portal_url
            ppath = utool.getPortalPath() + '/'
            path = ppath + utool.getRelativeUrl(conf)
            activities = [x.getObject() for x in self.portal_catalog.searchResults(portal_type='Activity',path=path)]
            for x in activities:
                if x.getMandatory() and (not x.getFreeforcommittee() or not self.aq_parent.portal_type in ["OrgCommittee","ProgCommittee"]):
                    act.append(x)
            for x in self.getActivities():
                if not x.getFreeforcommittee() or not self.aq_parent.portal_type in ["OrgCommittee","ProgCommittee"]:
                    try:
                        act.index(x)
                    except ValueError:
                        act.append(x)
            info = {}
            for x in act:
                i = [0.0,0.0,x.Title()]
                if not self.getNopayment():
                    if (self.getNovat()) and x.getSubtractvat():
                        vatcoef = 1 - x.getVat()/100
                    else:
                        vatcoef = 1
                        i[1] = x.getVat()
                    i[0] = round(vatcoef * x.getPrice(),1)
                s += i[0]
                info[ppath+utool.getRelativeUrl(x)] = i
            return (s,info)
        else:
            return (0.0,{})

    security.declarePublic('getMyFullname')
    def getMyFullname(self):
        """

        """

        x = self.getUserid()
        if hasattr(x,'getFullname'):
            return x.getFullname()
        else:
            return 'Undefined User'

    security.declarePublic('Title')
    def Title(self):
        """

        """

        return self.getMyFullname()

    security.declarePublic('getMyVarnumber')
    def getMyVarnumber(self):
        """

        """

        return self.getVarnumber()

    security.declarePublic('getMyPaid')
    def getMyPaid(self):
        """

        """

        return self.getPaid()

    security.declarePublic('getMyActivities')
    def getMyActivities(self):
        """

        """

        return self.getActivities()

    security.declarePublic('getMyPaiddate')
    def getMyPaiddate(self):
        """

        """

        return self.getPaiddate()


registerType(Conferee, PROJECTNAME)
# end of class Conferee

##code-section module-footer #fill in your manual code here
##/code-section module-footer



