# -*- coding: utf-8 -*-
#
# File: Conference.py
#
# Copyright (c) 2007 by []
# Generator: ArchGenXML Version 1.5.0
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """Josef Milota <milota@jcu.cz>"""
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.conference.NFolder import NFolder
from Products.conference.config import *

# additional imports from tagged value 'import'
from Products.CMFCore import CMFCorePermissions

##code-section module-header #fill in your manual code here
##/code-section module-header

schema = Schema((

    ImageField(
        name='conflogo',
        widget=ImageWidget(
            visible={'edit':'visible','view':'invisible'},
            label="Conference logo",
            label_msgid='conference_label_conflogo',
            i18n_domain='conference',
        ),
        languageIndependent=1,
        storage=AttributeStorage()
    ),

    DateTimeField(
        name='conferencestartdate',
        widget=CalendarWidget(
            label="Conference start date",
            visible={'edit':'visible','view':'invisible'},
            label_msgid='conference_label_conferencestartdate',
            i18n_domain='conference',
        ),
        languageIndependent=1
    ),

    DateTimeField(
        name='conferenceenddate',
        widget=CalendarWidget(
            label="Conference end date",
            visible={'edit':'visible','view':'invisible'},
            label_msgid='conference_label_conferenceenddate',
            i18n_domain='conference',
        ),
        languageIndependent=1
    ),

    TextField(
        name='conferenceinfo',
        allowable_content_types=('text/plain','text/html'),
        widget=RichWidget(
            visible={'edit':'visible','view':'invisible'},
            label="General conference information",
            description="This information will be displayed when viewing this page.",
            label_msgid='conference_label_conferenceinfo',
            description_msgid='conference_help_conferenceinfo',
            i18n_domain='conference',
        ),
        default_output_type='text/html'
    ),

    DateTimeField(
        name='deadline_article',
        widget=CalendarWidget(
            label="Deadline for article registration",
            visible={'edit':'visible','view':'invisible'},
            label_msgid='conference_label_deadline_article',
            i18n_domain='conference',
        ),
        languageIndependent=1
    ),

    TextField(
        name='contactaddress',
        allowable_content_types=('text/plain','text/html'),
        widget=RichWidget
        (
            visible={'edit':'visible','view':'invisible'},
            label='Contactaddress',
            label_msgid='conference_label_contactaddress',
            i18n_domain='conference',
        ),
        default_output_type='text/html'
    ),

    StringField(
        name='banknumberprefix',
        default="2005",
        widget=StringWidget(
            visible={'edit':'visible','view':'invisible'},
            label='Banknumberprefix',
            label_msgid='conference_label_banknumberprefix',
            i18n_domain='conference',
        ),
        languageIndependent=1,
        isMetadata=1
    ),

    TextField(
        name='bankaccountinfo',
        allowable_content_types=('text/plain','text/html'),
        widget=RichWidget
        (
            visible={'edit':'visible','view':'invisible'},
            label='Bankaccountinfo',
            label_msgid='conference_label_bankaccountinfo',
            i18n_domain='conference',
        ),
        default_output_type='text/html'
    ),

    StringField(
        name='currency',
        default="EUR",
        widget=SelectionWidget
        (
            visible={'edit':'visible','view':'invisible'},
            label='Currency',
            label_msgid='conference_label_currency',
            i18n_domain='conference',
        ),
        isMetadata=1,
        vocabulary='getCurrencies'
    ),

    LinesField(
        name='currencies',
        default=['EUR','USD','CZK'],
        widget=LinesWidget(
            visible={'edit':'visible','view':'invisible'},
            label='Currencies',
            label_msgid='conference_label_currencies',
            i18n_domain='conference',
        ),
        languageIndependent=1,
        isMetadata=1
    ),

    LinesField(
        name='expertises',
        default=["en:Education;cs:Vzdelavani","en:Informatics;cs:Informatika"],
        widget=LinesWidget(
            visible={'edit':'visible','view':'invisible'},
            label='Expertises',
            label_msgid='conference_label_expertises',
            i18n_domain='conference',
        ),
        isMetadata=1
    ),

    LinesField(
        name='activitytypes',
        default=["en:Section proceedings;cs:Jednani v sekci","en:Accommodation;cs:Ubytovani","en:Boarding;cs:Stravovani","en:Accompanying action;cs:Doprovodna akce","en:Culture program;cs:Kulturni program","en:Other;cs:Ostatni"],
        widget=LinesWidget(
            visible={'edit':'visible','view':'invisible'},
            label='Activitytypes',
            label_msgid='conference_label_activitytypes',
            i18n_domain='conference',
        ),
        isMetadata=1
    ),

    LinesField(
        name='articleforms',
        default=["en:Paper;cs:Prednaska","en:Presentation;cs:Prezentace","en:Poster;cs:Poster"],
        widget=LinesWidget(
            visible={'edit':'visible','view':'invisible'},
            label='Articleforms',
            label_msgid='conference_label_articleforms',
            i18n_domain='conference',
        ),
        isMetadata=1
    ),

    ComputedField(
        name='title',
        widget=ComputedWidget(
            visible={ 'edit' :'invisible', 'view' : 'invisible' },
            label='Title',
            label_msgid='conference_label_title',
            i18n_domain='conference',
        ),
        accessor="Title",
        isMetadata=1,
        searchable=1,
        id="title"
    ),

    FloatField(
        name='defaultvat',
        default=19.0,
        widget=DecimalWidget(
            visible={'edit':'visible','view':'invisible'},
            label='Defaultvat',
            label_msgid='conference_label_defaultvat',
            i18n_domain='conference',
        ),
        isMetadata=1
    ),

    IntegerField(
        name='batchnumber',
        default="20",
        widget=IntegerWidget(
            visible={'edit':'visible','view':'invisible'},
            label='Batchnumber',
            label_msgid='conference_label_batchnumber',
            i18n_domain='conference',
        ),
        isMetadata=1
    ),

    BooleanField(
        name='allow_email_notif',
        default=0,
        widget=BooleanWidget(
            i18n_domain="plone",
            visible={'edit':'visible','view':'invisible'},
            label='Allow_email_notif',
            label_msgid='conference_label_allow_email_notif',
        ),
        isMetadata=1
    ),

    StringField(
        name='conf_manager_email',
        default='',
        widget=StringWidget(
            visible={'edit':'visible','view':'invisible'},
            label='Conf_manager_email',
            label_msgid='conference_label_conf_manager_email',
            i18n_domain='conference',
        ),
        isMetadata=1,
        validators=('isEmail',)
    ),

    LinesField(
        name='topics',
        default=["en:Education;cs:Vzdelavani","en:Informatics;cs:Informatika"],
        widget=LinesWidget(
            label='Topics',
            label_msgid='conference_label_topics',
            i18n_domain='conference',
        )
    ),

),
)

##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

Conference_schema = OrderedBaseFolderSchema.copy() + \
    getattr(NFolder, 'schema', Schema(())).copy() + \
    schema.copy()

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class Conference(NFolder, OrderedBaseFolder):
    """The root object for a conference site.
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(NFolder,'__implements__',()),) + (getattr(OrderedBaseFolder,'__implements__',()),)

    # This name appears in the 'add' box
    archetype_name = 'Conference'

    meta_type = 'Conference'
    portal_type = 'Conference'
    allowed_content_types = ['Articles', 'Participants', 'OrgCommittee', 'ProgCommittee', 'Reviewers', 'Reviews', 'Activities', 'ConfCalendar'] + list(getattr(NFolder, 'allowed_content_types', []))
    filter_content_types = 0
    global_allow = 1
    content_icon = 'conference_icon.gif'
    immediate_view = 'base_view'
    default_view = 'base_view'
    suppl_views = ()
    typeDescription = "Conference"
    typeDescMsgId = 'description_edit_conference'


    actions =  (


       {'action': "string:${object_url}/personal_info",
        'category': "object",
        'id': 'personal_info',
        'name': 'personal_info',
        'permissions': ("View",),
        'condition': 'python:1'
       },


       {'action': "string:${object_url}/createBaseStructure",
        'category': "object_tabs",
        'id': 'baseStructure',
        'name': 'baseStructure',
        'permissions': ("Modify portal content",),
        'condition': 'python:1'
       },


       {'action': "string:${folder_url}/ConfCalendar/manage_main",
        'category': "object_tabs",
        'id': 'calendarconf',
        'name': 'calendarconf',
        'permissions': ("View",),
        'condition': 'python:hasattr(object,"ConfCalendar") and object.portal_membership.getAuthenticatedMember().has_permission("Modify portal content",object)'
       },


       {'action': "string:${folder_url}/portal_skins/custom_${object/getId}/manage_main",
        'category': "object_tabs",
        'id': 'layoutconf',
        'name': 'layoutconf',
        'permissions': ("Modify portal content",),
        'condition': 'python:hasattr(object.portal_skins,"custom_"+object.getId())'
       },


       {'action': "string:${object_url}/conference_statistics",
        'category': "object",
        'id': 'statistics',
        'name': 'statistics',
        'permissions': ("View",),
        'condition': 'python:(object.isCommitteeMember()!=[] or object.portal_membership.getAuthenticatedMember().has_permission("Modify portal content",object)) and not object.createStructureNeeded()'
       },


       {'action': "string:${object_url}/reports_conferee_form",
        'category': "object",
        'id': 'Reports',
        'name': 'Reports',
        'permissions': ("Modify portal content",),
        'condition': 'python:1'
       },


       {'action': "string:${object_url}/sendto_conferee_form",
        'category': "object",
        'id': 'sendto',
        'name': 'sendto',
        'permissions': ("Modify portal content",),
        'condition': 'python:1'
       },


       {'action': "string:${object_url}/conferee_registration",
        'category': "object",
        'id': 'editregistration',
        'name': 'editregistration',
        'permissions': ("View",),
        'condition': 'python:object.memberIsRegistered() and not object.portal_membership.isAnonymousUser()'
       },


       {'action': "string:${object_url}/conferee_registration",
        'category': "object",
        'id': 'registration',
        'name': 'registration',
        'permissions': ("View",),
        'condition': 'python:not object.memberIsRegistered() and not object.portal_membership.isAnonymousUser()'
       },


    )

    _at_rename_after_creation = True

    schema = Conference_schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header

    # Methods

    security.declarePublic('createBaseStructure')
    def createBaseStructure(self):
        """
        Create initial conference structure.
        """
        from Products.CalendarX.CalendarXFolder import CalendarXFolder
        from Acquisition import aq_base, aq_inner, aq_parent

        if not self.portal_properties.site_properties.hasProperty('conference_dietprefs'):
            self.portal_properties.site_properties.manage_addProperty('conference_dietprefs',["en:None;cs:\xc5\xbd\xc3\xa1dn\xc3\xa9","en:Vegetable diet;cs:Vegetari\xc3\xa1n"],'lines')

        if not self.portal_properties.site_properties.hasProperty('conference_perstitles'):
            self.portal_properties.site_properties.manage_addProperty('conference_perstitles',["en:Mr;cs:Pan","en:Mrs;cs:Pani"],'lines')

        if not self.hasProperty('right_slots'):
            props = self.portal_url.getPortalObject().getProperty('right_slots')
            self.manage_addProperty('right_slots',
                                list(props)+['here/my_conferences/macros/portlet',
                                             'here/my_articles/macros/portlet',
                                             'here/my_reviews/macros/portlet'],
                                'lines')

        for x in ['Activities',
                  'Articles',
                  'ConfCalendar',
                  'Participants',
                  'ProgCommittee',
                  'OrgCommittee',
                  'Reviewers',
                  'Reviews']:
            if not hasattr(self,x):
                self.invokeFactory(id=x,type_name=x,title=x)
                if x == 'Articles':
                    self[x].manage_permission('Add portal content', roles=['Member'],acquire=1),
                if x == 'ConfCalendar':
                    props = aq_inner(self).aq_acquire('CX_props_calendar')
                    self[x].manage_addFolder('CX_props_calendar','calendar properties')
                    for p in props.propertyIds():
                        if p != 'title':
                            self[x].CX_props_calendar.manage_addProperty(p,props.getProperty(p),props.getPropertyType(p))
                    myprops = {'dayOfWeekToStart':1,
                               'defaultView':'weekbyhour',
                               'dayViewStartHour':'7',
                               'dayViewEndHour':'23',
                               'hoursDisplay':'24.00',
                               'useHalfHours':0,
                               'showHeaderTitleAndIcons':1,
                               'showHighlightFullEvent':1,
                               'useMultiSubjects':0,
                               'showSubjectBar':0,
                               'restrictToThisFolder':1
                    }
                    self[x].CX_props_calendar.manage_changeProperties(myprops)
                    props = aq_inner(self).aq_acquire('CX_props_popup')
                    self[x].manage_addFolder('CX_props_popup','popup text properties')
                    for p in props.propertyIds():
                        if p != 'title':
                            self[x].CX_props_popup.manage_addProperty(p,props.getProperty(p),props.getPropertyType(p))
                    myprops = {'showPOPTitle':1,
                               'showPOPType':1,
                               'showPOPSubject':0,
                               'showPOPStart':1,
                               'showPOPEnd':1,
                               'showPOPDescription':1
                    }
                    self[x].CX_props_popup.manage_changeProperties(myprops)

        """
        st = self.portal_skins
        cid = self.getId()
        portal = self.portal_url.getPortalObject()
        skinpath = st.getSkinPaths()[0][1]
        st.addSkinSelection(cid,'custom_'+cid+','+skinpath)
        st.manage_addFolder('custom_'+cid,'')

        addscript = "\n  if req['SERVER_URL'].find('%s.jcu.cz') > -1:\n    context.changeSkin('%s')\n"  % (cid,cid)
        if hasattr(portal,'setSkin'):
            body = portal['setSkin'].body() + addscript
            portal['setSkin'].ZPythonScriptHTML_editAction(self.REQUEST, 'Skin changing script', '', body)
        """
        # XXX create special action for this
        self.setArticleDeadline()
        self.REQUEST.RESPONSE.redirect('.')

    security.declarePublic('getMandatoryActivities')
    def getMandatoryActivities(self):
        """

        """

        act = []
        for d in self.objectValues(['Activities']):
            for x in d.objectValues(['Activity']):
                if x.getMandatory():
                    act.append(x.getId())
        return act

    security.declarePublic('getConfObject')
    def getConfObject(self):
        """

        """

        return self

    security.declarePublic('memberIsRegistered')
    def memberIsRegistered(self):
        """

        """

        if self.getConfConferee():
            return True
        else:
            return False

    security.declarePublic('getMemberActivities')
    def getMemberActivities(self,userid=''):
        """

        """

        a = []
        for x in self.getConfConferee(userid):
            if x.getActivities():
                a += x.getActivities()
        return a

    security.declarePublic('getConfConferee')
    def getConfConferee(self,userid=''):
        """
        Return the list of Conferees.

        If userid is specified, returns only those Conferee objects that
        correspond this userid. Note that one user can be referenced
        from several Conferee objects - e.g. one in Participants and the
        other on ProgCommittee.
        """

        if userid:
            member = userid
        else:
            member = self.portal_membership.getAuthenticatedMember().getId()
        conf = self.getConfObject()
        m = []
        utool = self.portal_url
        path = utool.getPortalPath() + '/' + utool.getRelativeUrl(conf)
        conferees = [x.getObject() for x in self.portal_catalog.searchResults(portal_type='Conferee',path=path)]
        for x in conferees:
                if x.getUserid():
                    if x.getUserid().getId() == member:
                        m.append(x)
        return m

    security.declarePublic('getActivityTypes')
    def getActivityTypes(self):
        """

        """

        tit = {}
        if self.getActivitytypes():
            for t in self.getActivitytypes():
                tt = t.split(';')
                for k in tt:
                    if len(k)>2:
                        if tit.has_key(k[:2]):
                            tit[k[:2]] = tit[k[:2]] + [k[3:]]
                        else:
                            tit[k[:2]] = [k[3:]]
        if hasattr(self,'portal_languages'):
            prefLang = self.portal_languages.getLanguageBindings()[0]
        else:
            prefLang = 'en'
        if tit.has_key(prefLang):
            l = prefLang
        else:
            if tit:
                l = tit.keys()[0]
            else:
                l = ''
        if l:
            return tit[l]
        else:
            return []

    security.declarePublic('isCommitteeMember')
    def isCommitteeMember(self,userid=''):
        """

        """

        return [x for x in self.getConfConferee(userid) if x.aq_parent.portal_type in ['OrgCommittee','ProgCommittee']]

    security.declarePublic('createStructureNeeded')
    def createStructureNeeded(self):
        """

        """

        out = True
        for x in ['Activities','Articles','ConfCalendar','Participants','ProgCommittee','OrgCommittee','Reviewers','Reviews']:
            out = out and hasattr(self,x)
        return not out

    security.declarePublic('getExperTises')
    def getExperTises(self):
        """

        """

        tit = {}
        if self.getExpertises():
            for t in self.getExpertises():
                tt = t.split(';')
                for k in tt:
                    if len(k)>2:
                        if tit.has_key(k[:2]):
                            tit[k[:2]] = tit[k[:2]] + [k[3:]]
                        else:
                            tit[k[:2]] = [k[3:]]
        if hasattr(self,'portal_languages'):
            prefLang = self.portal_languages.getLanguageBindings()[0]
        else:
            prefLang = 'en'
        if tit.has_key(prefLang):
            l = prefLang
        else:
            if tit:
                l = tit.keys()[0]
            else:
                l = ''
        if l:
            return tit[l]
        else:
            return []

    security.declarePublic('setArticleDeadline')
    def setArticleDeadline(self):
        """
           Returns:
              1 - is before deadline
              0 - is after deadline
        """

        from time import time
        conf = self.getConfObject()
        arts = conf.objectValues(['Articles'])
        deadline = conf.getDeadline_article()
        now = time()
        if deadline:
            if deadline < now:
                for a in arts:
                    a.manage_permission('Add portal content', roles=[],acquire=1)
                return 0
        for a in arts:
            a.manage_permission('Add portal content', roles=['Member'],acquire=1)
        return 1

    security.declarePublic('getArticleForms')
    def getArticleForms(self):
        """

        """

        tit = {}
        if self.getArticleforms():
            for t in self.getArticleforms():
                tt = t.split(';')
                for k in tt:
                    if len(k)>2:
                        if tit.has_key(k[:2]):
                            tit[k[:2]] = tit[k[:2]] + [k[3:]]
                        else:
                            tit[k[:2]] = [k[3:]]
        if hasattr(self,'portal_languages'):
            prefLang = self.portal_languages.getLanguageBindings()[0]
        else:
            prefLang = 'en'
        if tit.has_key(prefLang):
            l = prefLang
        else:
            if tit:
                l = tit.keys()[0]
            else:
                l = ''
        if l:
            return tit[l]
        else:
            return []

    security.declarePublic('getObjectWfStats')
    def getObjectWfStats(self,object=None):
        """

        """

        if object == None:
            return {}
        else:
            out = {}
            for obj in object.objectValues():
                state = self.portal_workflow.getInfoFor(obj,'review_state','')
                if out.has_key(state):
                    out[state] += 1
                else:
                    out[state] = 1
            return out

    security.declarePublic('getPaymentSums')
    def getPaymentSums(self,types=['Participants','OrgCommittee','ProgCommittee']):
        """

        """

        conf = self.getConfObject()
        utool = self.portal_url
        sum = {}
        for t in types:
            for obj in conf.objectValues([t]):
                i = obj.getId()
                sum[i] = [0.0,0.0]
                for c in obj.objectValues(['Conferee']):
                    sum[i][0] += c.getPayment()
                    sum[i][1] += c.getPaid()
                for c in obj.objectValues(['Reviewer']):
                    sum[i][1] += c.getPaid()
        k = sum.keys()
        sum['Total'] = [0.0,0.0]
        for t in k:
            sum['Total'][0] += sum[t][0]
            sum['Total'][1] += sum[t][1]
        return sum

    security.declarePublic('isReviewsManager')
    def isReviewsManager(self):
        """

        """

        utool = self.portal_url
        path = utool.getPortalPath() + '/' + utool.getRelativeUrl(self)
        reviews = [x.getObject() for x in self.portal_catalog.searchResults(portal_type='Reviews',path=path)]
        out = False
        has_perm = self.portal_membership.getAuthenticatedMember().has_permission

        for r in reviews:
            if has_perm("Modify portal content",r):
                out = True
            else:
                out = False
                break
        return out

    security.declarePublic('getLocalizedTopics')
    def getLocalizedTopics(self):
        """
        """
        tit = {}
        if self.getTopics():
            for t in self.getTopics():
                tt = t.split(';')
                for k in tt:
                    if len(k)>2:
                        if tit.has_key(k[:2]):
                            tit[k[:2]] = tit[k[:2]] + [k[3:]]
                        else:
                            tit[k[:2]] = [k[3:]]
        if hasattr(self,'portal_languages'):
            prefLang = self.portal_languages.getLanguageBindings()[0]
        else:
            prefLang = 'en'
        if tit.has_key(prefLang):
            l = prefLang
        else:
            if tit:
                l = tit.keys()[0]
            else:
                l = ''
        if l:
            return tit[l]
        else:
            return []


registerType(Conference, PROJECTNAME)
# end of class Conference

##code-section module-footer #fill in your manual code here
##/code-section module-footer



