# -*- coding: utf-8 -*-
#
# File: conference.py
#
# Copyright (c) 2007 by []
# Generator: ArchGenXML Version 1.5.0
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """Josef Milota <milota@jcu.cz>"""
__docformat__ = 'plaintext'


from Products.CMFCore.utils import getToolByName
from Products.CMFCore.WorkflowTool import addWorkflowFactory
from Products.DCWorkflow.DCWorkflow import DCWorkflowDefinition
from Products.ExternalMethod.ExternalMethod import ExternalMethod
from Products.conference.config import *

##code-section create-workflow-module-header #fill in your manual code here
##/code-section create-workflow-module-header


productname = 'conference'

def setupconference_article_workflow(self, workflow):
    """Define the conference_article_workflow workflow.
    """

    workflow.setProperties(title='conference_article_workflow')

    ##code-section create-workflow-setup-method-header #fill in your manual code here
    ##/code-section create-workflow-setup-method-header


    for s in ['pending_review', 'reviewed', 'rejected', 'published', 'pending_publish', 'private']:
        workflow.states.addState(s)

    for t in ['hide', 'submit_publish', 'submit_review', 'reject', 'retract', 'publish', 'reviewed']:
        workflow.transitions.addTransition(t)

    for v in ['review_history', 'comments', 'time', 'actor', 'action']:
        workflow.variables.addVariable(v)

    workflow.addManagedPermission('View')
    workflow.addManagedPermission('Modify portal content')
    workflow.addManagedPermission('Access contents information')
    workflow.addManagedPermission('conference: View article review version')
    workflow.addManagedPermission('conference: View article final version')

    for l in []:
        if not l in workflow.worklists.objectValues():
            workflow.worklists.addWorklist(l)

    ## Initial State

    workflow.states.setInitialState('private')

    ## States initialization

    stateDef = workflow.states['pending_review']
    stateDef.setProperties(title="""pending_review""",
                           transitions=['hide', 'reviewed', 'publish', 'reject'])
    stateDef.setPermission('View',
                           0,
                           ['Manager', 'Owner', 'Reviewer'])
    stateDef.setPermission('Modify portal content',
                           0,
                           ['Manager', 'Owner'])
    stateDef.setPermission('Access contents information',
                           0,
                           ['Manager', 'Owner', 'Reviewer'])
    stateDef.setPermission('conference: View article review version',
                           0,
                           ['Manager', 'Owner', 'Reviewer'])
    stateDef.setPermission('conference: View article final version',
                           0,
                           ['Manager'])

    stateDef = workflow.states['reviewed']
    stateDef.setProperties(title="""reviewed""",
                           transitions=['retract', 'hide', 'reject', 'submit_publish'])
    stateDef.setPermission('View',
                           0,
                           ['Manager', 'Owner', 'Reviewer'])
    stateDef.setPermission('Modify portal content',
                           0,
                           ['Manager', 'Owner'])
    stateDef.setPermission('Access contents information',
                           0,
                           ['Manager', 'Owner', 'Reviewer'])
    stateDef.setPermission('conference: View article review version',
                           0,
                           ['Manager', 'Owner', 'Reviewer'])
    stateDef.setPermission('conference: View article final version',
                           0,
                           ['Manager', 'Owner', 'Reviewer'])

    stateDef = workflow.states['rejected']
    stateDef.setProperties(title="""rejected""",
                           transitions=['hide', 'reviewed'])
    stateDef.setPermission('View',
                           0,
                           ['Manager', 'Owner', 'Reviewer'])
    stateDef.setPermission('Modify portal content',
                           0,
                           ['Manager'])
    stateDef.setPermission('Access contents information',
                           0,
                           ['Manager', 'Owner', 'Reviewer'])
    stateDef.setPermission('conference: View article review version',
                           0,
                           ['Manager', 'Owner', 'Reviewer'])
    stateDef.setPermission('conference: View article final version',
                           0,
                           ['Manager', 'Owner', 'Reviewer'])

    stateDef = workflow.states['published']
    stateDef.setProperties(title="""published""",
                           transitions=['retract', 'hide'])
    stateDef.setPermission('View',
                           0,
                           ['Manager', 'Owner', 'Reviewer', 'Member', 'Anonymous'])
    stateDef.setPermission('Modify portal content',
                           0,
                           ['Manager'])
    stateDef.setPermission('Access contents information',
                           0,
                           ['Manager', 'Owner', 'Reviewer', 'Member', 'Anonymous'])
    stateDef.setPermission('conference: View article review version',
                           0,
                           ['Manager', 'Owner', 'Reviewer'])
    stateDef.setPermission('conference: View article final version',
                           0,
                           ['Manager', 'Owner', 'Reviewer'])

    stateDef = workflow.states['pending_publish']
    stateDef.setProperties(title="""pending_publish""",
                           transitions=['publish', 'retract'])
    stateDef.setPermission('View',
                           0,
                           ['Manager', 'Owner', 'Reviewer'])
    stateDef.setPermission('Modify portal content',
                           0,
                           ['Manager', 'Owner'])
    stateDef.setPermission('Access contents information',
                           0,
                           ['Manager', 'Owner', 'Reviewer'])
    stateDef.setPermission('conference: View article review version',
                           0,
                           ['Manager', 'Owner', 'Reviewer'])
    stateDef.setPermission('conference: View article final version',
                           0,
                           ['Manager', 'Owner', 'Reviewer'])

    stateDef = workflow.states['private']
    stateDef.setProperties(title="""private""",
                           transitions=['submit_review', 'publish', 'reviewed', 'reject'])
    stateDef.setPermission('View',
                           0,
                           ['Manager', 'Owner', 'Reviewer'])
    stateDef.setPermission('Modify portal content',
                           0,
                           ['Manager', 'Owner'])
    stateDef.setPermission('Access contents information',
                           0,
                           ['Manager', 'Owner', 'Reviewer'])
    stateDef.setPermission('conference: View article review version',
                           0,
                           ['Manager', 'Owner'])
    stateDef.setPermission('conference: View article final version',
                           0,
                           ['Manager'])

    ## Transitions initialization

    ## Creation of workflow scripts
    for wf_scriptname in ['articleEmailNotification']:
        if not wf_scriptname in workflow.scripts.objectIds():
            workflow.scripts._setObject(wf_scriptname,
                ExternalMethod(wf_scriptname, wf_scriptname,
                productname + '.conference_article_workflow_scripts',
                wf_scriptname))

    transitionDef = workflow.transitions['hide']
    transitionDef.setProperties(title="""hide""",
                                new_state_id="""private""",
                                trigger_type=1,
                                script_name="""""",
                                after_script_name="""articleEmailNotification""",
                                actbox_name="""hide""",
                                actbox_url="""""",
                                actbox_category="""workflow""",
                                props={'guard_roles': 'Manager;Owner;Reviewer'},
                                )

    ## Creation of workflow scripts
    for wf_scriptname in ['articleEmailNotification']:
        if not wf_scriptname in workflow.scripts.objectIds():
            workflow.scripts._setObject(wf_scriptname,
                ExternalMethod(wf_scriptname, wf_scriptname,
                productname + '.conference_article_workflow_scripts',
                wf_scriptname))

    transitionDef = workflow.transitions['submit_publish']
    transitionDef.setProperties(title="""submit_publish""",
                                new_state_id="""pending_publish""",
                                trigger_type=1,
                                script_name="""""",
                                after_script_name="""articleEmailNotification""",
                                actbox_name="""submit_publish""",
                                actbox_url="""""",
                                actbox_category="""workflow""",
                                props={'guard_roles': 'Manager;Owner'},
                                )

    ## Creation of workflow scripts
    for wf_scriptname in ['articleEmailNotification']:
        if not wf_scriptname in workflow.scripts.objectIds():
            workflow.scripts._setObject(wf_scriptname,
                ExternalMethod(wf_scriptname, wf_scriptname,
                productname + '.conference_article_workflow_scripts',
                wf_scriptname))

    transitionDef = workflow.transitions['submit_review']
    transitionDef.setProperties(title="""submit_review""",
                                new_state_id="""pending_review""",
                                trigger_type=1,
                                script_name="""""",
                                after_script_name="""articleEmailNotification""",
                                actbox_name="""submit_review""",
                                actbox_url="""""",
                                actbox_category="""workflow""",
                                props={'guard_roles': 'Manager;Owner'},
                                )

    ## Creation of workflow scripts
    for wf_scriptname in ['articleEmailNotification']:
        if not wf_scriptname in workflow.scripts.objectIds():
            workflow.scripts._setObject(wf_scriptname,
                ExternalMethod(wf_scriptname, wf_scriptname,
                productname + '.conference_article_workflow_scripts',
                wf_scriptname))

    transitionDef = workflow.transitions['reject']
    transitionDef.setProperties(title="""reject""",
                                new_state_id="""rejected""",
                                trigger_type=1,
                                script_name="""""",
                                after_script_name="""articleEmailNotification""",
                                actbox_name="""reject""",
                                actbox_url="""""",
                                actbox_category="""workflow""",
                                props={'guard_roles': 'Manager;Reviewer'},
                                )

    ## Creation of workflow scripts
    for wf_scriptname in ['articleEmailNotification']:
        if not wf_scriptname in workflow.scripts.objectIds():
            workflow.scripts._setObject(wf_scriptname,
                ExternalMethod(wf_scriptname, wf_scriptname,
                productname + '.conference_article_workflow_scripts',
                wf_scriptname))

    transitionDef = workflow.transitions['retract']
    transitionDef.setProperties(title="""retract""",
                                new_state_id="""reviewed""",
                                trigger_type=1,
                                script_name="""""",
                                after_script_name="""articleEmailNotification""",
                                actbox_name="""retract""",
                                actbox_url="""""",
                                actbox_category="""workflow""",
                                props={'guard_roles': 'Manager'},
                                )

    ## Creation of workflow scripts
    for wf_scriptname in ['articleEmailNotification']:
        if not wf_scriptname in workflow.scripts.objectIds():
            workflow.scripts._setObject(wf_scriptname,
                ExternalMethod(wf_scriptname, wf_scriptname,
                productname + '.conference_article_workflow_scripts',
                wf_scriptname))

    transitionDef = workflow.transitions['publish']
    transitionDef.setProperties(title="""publish""",
                                new_state_id="""published""",
                                trigger_type=1,
                                script_name="""""",
                                after_script_name="""articleEmailNotification""",
                                actbox_name="""publish""",
                                actbox_url="""""",
                                actbox_category="""workflow""",
                                props={'guard_roles': 'Manager'},
                                )

    ## Creation of workflow scripts
    for wf_scriptname in ['articleEmailNotification']:
        if not wf_scriptname in workflow.scripts.objectIds():
            workflow.scripts._setObject(wf_scriptname,
                ExternalMethod(wf_scriptname, wf_scriptname,
                productname + '.conference_article_workflow_scripts',
                wf_scriptname))

    transitionDef = workflow.transitions['reviewed']
    transitionDef.setProperties(title="""reviewed""",
                                new_state_id="""reviewed""",
                                trigger_type=1,
                                script_name="""""",
                                after_script_name="""articleEmailNotification""",
                                actbox_name="""reviewed""",
                                actbox_url="""""",
                                actbox_category="""workflow""",
                                props={'guard_roles': 'Manager;Reviewer'},
                                )

    ## State Variable
    workflow.variables.setStateVar('review_state')

    ## Variables initialization
    variableDef = workflow.variables['review_history']
    variableDef.setProperties(description="""Provides access to workflow history""",
                              default_value="""""",
                              default_expr="""state_change/getHistory""",
                              for_catalog=0,
                              for_status=0,
                              update_always=0,
                              props={'guard_permissions': 'Request review; Review portal content'})

    variableDef = workflow.variables['comments']
    variableDef.setProperties(description="""Comments about the last transition""",
                              default_value="""""",
                              default_expr="""python:state_change.kwargs.get('comment', '')""",
                              for_catalog=0,
                              for_status=1,
                              update_always=1,
                              props=None)

    variableDef = workflow.variables['time']
    variableDef.setProperties(description="""Time of the last transition""",
                              default_value="""""",
                              default_expr="""state_change/getDateTime""",
                              for_catalog=0,
                              for_status=1,
                              update_always=1,
                              props=None)

    variableDef = workflow.variables['actor']
    variableDef.setProperties(description="""The ID of the user who performed the last transition""",
                              default_value="""""",
                              default_expr="""user/getId""",
                              for_catalog=0,
                              for_status=1,
                              update_always=1,
                              props=None)

    variableDef = workflow.variables['action']
    variableDef.setProperties(description="""The last transition""",
                              default_value="""""",
                              default_expr="""transition/getId|nothing""",
                              for_catalog=0,
                              for_status=1,
                              update_always=1,
                              props=None)

    ## Worklists Initialization


    # WARNING: below protected section is deprecated.
    # Add a tagged value 'worklist' with the worklist name to your state(s) instead.

    ##code-section create-workflow-setup-method-footer #fill in your manual code here
    ##/code-section create-workflow-setup-method-footer



def createconference_article_workflow(self, id):
    """Create the workflow for conference.
    """

    ob = DCWorkflowDefinition(id)
    setupconference_article_workflow(self, ob)
    return ob

addWorkflowFactory(createconference_article_workflow,
                   id='conference_article_workflow',
                   title='conference_article_workflow')

##code-section create-workflow-module-footer #fill in your manual code here
##/code-section create-workflow-module-footer

