# -*- coding: utf-8 -*-
#
# File: conference.py
#
# Copyright (c) 2007 by []
# Generator: ArchGenXML Version 1.5.0
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """Josef Milota <milota@jcu.cz>"""
__docformat__ = 'plaintext'


# Workflow Scripts for: conference_review_workflow

##code-section workflow-script-header #fill in your manual code here
##/code-section workflow-script-header


def setReviewRoles(self,state_change,**kw):
    o = state_change.object
    m = state_change.getPortal().portal_membership

    anconf = o.getConfObject().getAllow_email_notif()
    rcreator = o.Creator()
    rcreators = self.portal_catalog.searchResults(portal_type='ConfMember',id=rcreator)
    if rcreators:
        rcreator = rcreators[0].getObject()
        anrcreator = rcreator.getAllow_email_notif()
        emailrcreator = rcreator.getEmail()
    else:
        anrcreator = False
    anreviewer = False
    article = o.getArticle()
    if article:
        m.setLocalRoles(o,[article.Creator()],'Author')
    rev = o.getReviewer()
    if rev:
        r = rev.getUserid()
        if r:
            anreviewer = r.getAllow_email_notif()
            emailreviewer = r.getEmail()
            o.setCreators(r.getUserName())
            m.setLocalRoles(o,[r.getUserName()],'Reviewer')
            m.setLocalRoles(article,[r.getUserName()],'Reviewer')
    if anconf:
        if anrcreator:
            o.email_notif_send(send_to_address=emailrcreator,object=o)
        if anreviewer:
            o.email_notif_send(send_to_address=emailreviewer,object=o)



def setArticlePrivate(self,state_change,**kw):
    o = state_change.object
    m = state_change.getPortal().portal_membership

    anconf = o.getConfObject().getAllow_email_notif()
    rcreator = o.Creator()
    rcreators = self.portal_catalog.searchResults(portal_type='ConfMember',id=rcreator)
    if rcreators:
        rcreator = rcreators[0].getObject()
        anrcreator = rcreator.getAllow_email_notif()
        emailrcreator = rcreator.getEmail()
    else:
        anrcreator = False
    anreviewer = False

    article = o.getArticle()
    if article:
        revs = article.getBRefs(relationship='article')
    else:
        revs = []
    w = state_change.getPortal().portal_workflow
    if w.getInfoFor(article, 'review_state') in ['reviewed','pending_review','rejected'] and len(revs) == 1:
        w.doActionFor(article,'hide')

    rev = o.getReviewer()
    if rev:
        r = rev.getUserid()
        if r:
            anreviewer = r.getAllow_email_notif()
            emailreviewer = r.getEmail()
    if anconf:
        if anrcreator:
            o.email_notif_send(send_to_address=emailrcreator,object=o)
        if anreviewer:
            o.email_notif_send(send_to_address=emailreviewer,object=o)



def setArticleReviewed(self,state_change,**kw):
    o = state_change.object
    m = state_change.getPortal().portal_membership

    anconf = o.getConfObject().getAllow_email_notif()
    rcreator = o.Creator()
    rcreators = self.portal_catalog.searchResults(portal_type='ConfMember',id=rcreator)
    if rcreators:
        rcreator = rcreators[0].getObject()
        anrcreator = rcreator.getAllow_email_notif()
        emailrcreator = rcreator.getEmail()
    else:
        anrcreator = False
    anreviewer = False

    article = o.getArticle()
    if article:
        revs = article.getBRefs(relationship='article')
    else:
        revs = []
    w = state_change.getPortal().portal_workflow
    if w.getInfoFor(article, 'review_state') in ['private','pending_review','rejected'] and len(revs) == 1:
        w.doActionFor(article,'reviewed')

    rev = o.getReviewer()
    if rev:
        r = rev.getUserid()
        if r:
            anreviewer = r.getAllow_email_notif()
            emailreviewer = r.getEmail()
    if anconf:
        if anrcreator:
            o.email_notif_send(send_to_address=emailrcreator,object=o)
        if anreviewer:
            o.email_notif_send(send_to_address=emailreviewer,object=o)



def setArticleRejected(self,state_change,**kw):
    o = state_change.object
    m = state_change.getPortal().portal_membership

    anconf = o.getConfObject().getAllow_email_notif()
    rcreator = o.Creator()
    rcreators = self.portal_catalog.searchResults(portal_type='ConfMember',id=rcreator)
    if rcreators:
        rcreator = rcreators[0].getObject()
        anrcreator = rcreator.getAllow_email_notif()
        emailrcreator = rcreator.getEmail()
    else:
        anrcreator = False
    anreviewer = False

    article = o.getArticle()
    if article:
        revs = article.getBRefs(relationship='article')
    else:
        revs = []
    w = state_change.getPortal().portal_workflow
    if w.getInfoFor(article, 'review_state') in ['private','pending_review','reviewed'] and len(revs) == 1:
        w.doActionFor(article,'reject')

    rev = o.getReviewer()
    if rev:
        r = rev.getUserid()
        if r:
            anreviewer = r.getAllow_email_notif()
            emailreviewer = r.getEmail()
    if anconf:
        if anrcreator:
            o.email_notif_send(send_to_address=emailrcreator,object=o)
        if anreviewer:
            o.email_notif_send(send_to_address=emailreviewer,object=o)



def setPrivateState(self,state_change,**kw):
    o = state_change.object
    m = state_change.getPortal().portal_membership

    anconf = o.getConfObject().getAllow_email_notif()
    rcreator = o.Creator()
    rcreators = self.portal_catalog.searchResults(portal_type='ConfMember',id=rcreator)
    if rcreators:
        rcreator = rcreators[0].getObject()
        anrcreator = rcreator.getAllow_email_notif()
        emailrcreator = rcreator.getEmail()
    else:
        anrcreator = False
    anreviewer = False

    rev = o.getReviewer()
    if rev:
        r = rev.getUserid()
        if r:
            anreviewer = r.getAllow_email_notif()
            emailreviewer = r.getEmail()
    if anconf:
        if anrcreator:
            o.email_notif_send(send_to_address=emailrcreator,object=o)
        if anreviewer:
            o.email_notif_send(send_to_address=emailreviewer,object=o)


