# -*- coding: utf-8 -*-
#
# File: LFolder.py
#
# Copyright (c) 2007 by []
# Generator: ArchGenXML Version 1.5.0
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """Josef Milota <milota@jcu.cz>"""
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.conference.config import *

# additional imports from tagged value 'import'
from Products.ATContentTypes.atct import ATBTreeFolder

##code-section module-header #fill in your manual code here
##/code-section module-header

schema = Schema((

    LinesField(
        name='titles',
        widget=LinesWidget(
            label='Titles',
            label_msgid='conference_label_titles',
            i18n_domain='conference',
        ),
        required=1,
        isMetadata=1,
        searchable=1,
        default_method="createDefaultTitles"
    ),

    TextField(
        name='dataregistration',
        widget=RichWidget
        (
            label="Data for batch registration",
            visible={ 'edit' :'invisible', 'view' : 'invisible' },
            label_msgid='conference_label_dataregistration',
            i18n_domain='conference',
        ),
        isMetadata=1,
        write_permission="conference: Edit content",
        read_permission="Modify portal content"
    ),

    TextField(
        name='datapaid',
        widget=RichWidget
        (
            label="Data for batch import of paid information",
            visible={ 'edit' :'invisible', 'view' : 'invisible' },
            label_msgid='conference_label_datapaid',
            i18n_domain='conference',
        ),
        isMetadata=1,
        write_permission="conference: Edit content",
        read_permission="Modify portal content"
    ),

    ComputedField(
        name='title',
        widget=ComputedWidget(
            label_msgid="label_title",
            i18n_domain="plone",
            visible={ 'edit' :'invisible', 'view' : 'invisible' },
            label='Title',
        ),
        expression="context.Title_meta_type()",
        accessor="Title",
        searchable=1
    ),

),
)

##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

LFolder_schema = getattr(ATBTreeFolder, 'schema', Schema(())).copy() + \
    schema.copy()

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class LFolder(ATBTreeFolder, BaseBTreeFolder):
    """
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(ATBTreeFolder,'__implements__',()),) + (getattr(BaseBTreeFolder,'__implements__',()),)

    allowed_content_types = [] + list(getattr(ATBTreeFolder, 'allowed_content_types', []))
    _at_rename_after_creation = True

    schema = LFolder_schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header

    # Methods

    security.declarePublic('Title_meta_type')
    def Title_meta_type(self):
        """

        """

        if hasattr(self,'translate'):
            return self.translate(domain='plone',msgid=self.meta_type)
        else:
            return self.meta_type

    security.declareProtected("Modify portal content", 'confereeBatchRegistration')
    def confereeBatchRegistration(self):
        """
        Batch registration - data should be in the form:
            portal_username;activities_list
        (for conferees)
        or
            portal_username
        (for reviewers)
        where
        portal_username is username of registered portal Member and
        activities_list is in the form:
            activity_id1,activity_id2,...
        (comma separated list of activity ids),
        """

        import time
        out = ''
        type_name = self.allowed_content_types[0]
        d1 = str.split(self.getDataregistration().replace('\r',''),"\n"); n = 0; k = 0
        d = []
        for x in d1:
            if len(x)>0:
                if not x.lstrip()[0] in ['#']:
                    d.append(x)
        users = [y.getUserid().getId() for y in self.objectValues(['Conferee','Reviewer']) if y.getUserid()]
        for i in d:
            x = str.split(i,";")
            if (len(x)>=2) or (len(x)==1 and self.portal_type == 'Reviewers'):
              n = n + 1
              if self.portal_type != 'Reviewers':
                  acts = x[1].split(',')
                  alist = []
                  alistnames = []
                  for a in acts:
                      if hasattr(self.aq_parent.Activities,a):
                          act = self.aq_parent.Activities[a]
                          #if time.time() <= act.getDeadline() and act.getUtilizedcapacity() < act.getCapacity():
                          #   Do not check the activity conditions!
                          alist.append(act.UID())
                          alistnames.append(a)
              if x[0] in users:
                  out += 'Set new values for conferee with username="%s"' % x[0]
                  newid = [y.getId() for y in self.portal_membership.getMemberById(x[0]).getBRefs(relationship='userid') if y.aq_parent == self][0]
              else:
                  if x[0] in self.portal_membership.listMemberIds():
                      newid = self.generateUniqueId(type_name)
                      self.invokeFactory(id=newid,type_name=type_name,userid=self.portal_membership.getMemberById(x[0]).UID())
                      self.portal_membership.setLocalRoles(self[newid],[x[0]],'Owner')
                      users.append(x[0])
                      if self.portal_type != 'Reviewers':
                          out += 'Registered new conferee with username="%s"' % x[0]
                      else:
                          out += 'Registered new reviewer with username="%s"' % x[0]
                      k = k + 1
                  else:
                      out += 'UNKNOWN member username="%s\n"' % x[0]
                      newid = ''
              if newid:
                  if self.portal_type != 'Reviewers':
                      self[newid].setActivities(alist)
                      out += ', activities="%s"\n' % ','.join(alistnames)
                  else:
                      out += '\n'
        out += 'Imported %s items, created %s and UNPROCESSED %s.\n' % (n,k,len(d) - n)
        return out

    security.declareProtected("Modify portal content", 'confereeBatchPaid')
    def confereeBatchPaid(self):
        """
        Batch importing of paid information - data should be in the form:
            varnumber;paid;paiddate;novat;nopayment
        (for conferees)
        or
            portal_username;paid;paiddate
        (for reviewers)
        where
        portal_username is username of registered portal Member,
        paid is the paid money,
        paiddate is the date of payment in ISO format (YYYY-MM-DD),
        novat defines the conferee that will pay no
        VAT for actions with subtract attribute set to True and
        nopayment defines the conferee that will pay no payments.
        """

        import datetime
        import time
        out = ''
        type_name = self.allowed_content_types[0]
        d1 = str.split(self.getDatapaid().replace('\r',''),"\n"); n = 0;
        d = []
        for x in d1:
            if len(x)>0:
                if not x.lstrip()[0] in ['#']:
                    d.append(x)
        userobjs = [x for x in self.objectValues(['Conferee','Reviewer']) if x.getUserid()]
        users = [x.getUserid().getId() for x in userobjs]
        varnums = {}
        for x in userobjs:
            if x.portal_type == 'Conferee':
                varnums[x.getVarnumber()] = x.getUserid().getId()
            else:
                varnums[x.getUserid().getId()] = x.getUserid().getId()
        for i in d:
            x = str.split(i,";")
            if (len(x)>=5) or (len(x)>=3 and self.portal_type == 'Reviewers'):
              if x[0] in varnums.keys():
                  x0 = varnums[x[0]]
              else:
                  x0 = '(%s)' % x[0]
              if x0 in users:
                  out += 'Set new values for conferee with username="%s"' % x0
                  newid = [y.getId() for y in self.portal_membership.getMemberById(x0).getBRefs(relationship='userid') if y.aq_parent == self and y.getVarnumber() == x[0]][0]
              else:
                  out += 'UNKNOWN user with username or varnumber = "%s"\n' % x0
                  newid = ''
              if newid:
                  n = n + 1
                  f = x[1].replace(' ','')
                  if f:
                      p = float(f)
                  else:
                      p = 0.0
                  self[newid].setPaid(p)
                  out += ', paid="%s"' % f
                  pd_str = x[2].replace('/','-')
                  pd = pd_str.split('-')
                  try:
                      pd = [int(xx) for xx in pd]
                      pd = time.mktime((pd[0],pd[1],pd[2],0,0,0,0,0,1))
                  except:
                      pd_str = time.strftime("%Y-%m-%d",time.localtime())
                      pd = time.time()
                  if p > 0.0:
                      self[newid].setPaiddate(pd)
                  else:
                      self[newid].setPaiddate(None)
                      pd_str = 'None'
                  out += ', paiddate="%s"' % pd_str
                  if self[newid].portal_type == 'Conferee':
                      out += ', varnumber="%s"' % x[0]
                      v = x[3].replace(' ','')
                      if (v == '0') or (v == ''):
                          v = False
                      else:
                          v = True
                      self[newid].setNovat(v)
                      out += ', novat="%s"' % v
                      v = x[4].replace(' ','')
                      if (v == '0') or (v == ''):
                          v = False
                      else:
                          v = True
                      self[newid].setNopayment(v)
                      out += ', nopayment="%s"\n' % v
                  else:
                      out += '\n'

        out += 'Imported %s items, UNPROCESSED %s.\n' % (n,len(d) - n)
        return out

    security.declarePublic('Title')
    def Title(self):
        """

        """

        tit = {}
        if self.getTitles():
            for t in self.getTitles():
                if len(t)>2:
                    tit[t[:2]] = t[3:]
        if hasattr(self,'portal_languages'):
            prefLang = self.portal_languages.getLanguageBindings()[0]
        else:
            prefLang = 'en'
        if tit.has_key(prefLang):
            l = prefLang
        else:
            if tit:
                l = tit.keys()[0]
            else:
                l = ''
        if l:
            return tit[l]
        else:
            if self.getTitles():
                return self.getTitles()[0]
            else:
                if hasattr(self,'translate'):
                    return self.translate(domain='plone',msgid=self.meta_type)
                else:
                    return self.meta_type

    security.declarePublic('createDefaultTitles')
    def createDefaultTitles(self):
        """

        """

        if hasattr(self,'translate'):
            ten = self.translate(domain='plone',msgid=self.meta_type,target_language='en')
            tcs = self.translate(domain='plone',msgid=self.meta_type,target_language='cs')
            return ['en:'+ten,'cs:'+tcs]
        else:
            return ['en:'+self.meta_type,'cs:'+self.meta_type]

    security.declareProtected("Modify portal content", 'exportConferees')
    def exportConferees(self):
        """

        """

        import time
        userobjs = [x for x in self.objectValues(['Conferee','Reviewer']) if x.getUserid()]
        out = '# DATA FOR BATCH REGISTRATION - structure:\n'
        out += '#    portal_username;activities_list;fullname\n'
        out += '# (activities_list is omitted for reviewers)\n'
        for x in userobjs:
            alist = ''
            if self.portal_type in ['Participants','OrgCommittee','ProgCommittee']:
                alist = ';' + ','.join([a.getId() for a in x.getActivities()])
            out += '%s%s;%s\n' % (x.getUserid().getId(),alist,x.getUserid().getFullname())
        out += '#\n'
        out += '# DATA FOR BATCH PAID - structure:\n'
        out += '#    varnumber;paid;paiddate;novat;nopayment;fullname;payment\n'
        out += '# (for conferees)\n'
        out += '#    portal_username;paid;paiddate;fullname\n'
        out += '# (for reviewers)\n'
        for x in userobjs:
            alist = ''
            if x.getPaiddate():
                paiddate = time.strftime("%Y-%m-%d",time.localtime(x.getPaiddate()))
            else:
                paiddate = ''
            if self.portal_type in ['Participants','OrgCommittee','ProgCommittee']:
                if x.getNovat():
                    novat = '1'
                else:
                    novat = '0'
                if x.getNopayment():
                    nopayment = '1'
                else:
                    nopayment = '0'
                out += '%s;%s;%s;%s;%s;%s;%s\n' % (x.getVarnumber(),x.getPaid(),paiddate,novat,nopayment,x.getUserid().getFullname(),x.getPayment())
            if self.portal_type in ['Reviewers']:
                out += '%s;%s;%s;%s\n' % (x.getUserid().getId(),x.getPaid(),paiddate,x.getUserid().getFullname())
        return out

# end of class LFolder

##code-section module-footer #fill in your manual code here
##/code-section module-footer



