# -*- coding: utf-8 -*-
#
# File: Review.py
#
# Copyright (c) 2007 by []
# Generator: ArchGenXML Version 1.5.0
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """Josef Milota <milota@jcu.cz>"""
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.conference.config import *

# additional imports from tagged value 'import'
from Products.ATReferenceBrowserWidget.ATReferenceBrowserWidget import *

##code-section module-header #fill in your manual code here
##/code-section module-header

schema = Schema((

    ComputedField(
        name='reviewversion',
        widget=ComputedWidget(
            label='Reviewversion',
            label_msgid='conference_label_reviewversion',
            i18n_domain='conference',
        ),
        expression="context.getArticleFile()",
        read_permission="conference: View review comment"
    ),

    FileField(
        name='review',
        default=None,
        widget=FileWidget(
            macro="file_widget_macro",
            label='Review',
            label_msgid='conference_label_review',
            i18n_domain='conference',
        ),
        storage=AttributeStorage(),
        write_permission="conference: View review comment",
        read_permission="conference: View review comment"
    ),

    TextField(
        name='comment',
        allowable_content_types=('text/plain','text/html'),
        widget=RichWidget
        (
            label='Comment',
            label_msgid='conference_label_comment',
            i18n_domain='conference',
        ),
        default_output_type='text/html',
        read_permission="conference: View review comment",
        write_permission="conference: View review comment"
    ),

    ReferenceField(
        name='reviewer',
        widget=ReferenceBrowserWidget
        (
            startup_directory="../../Reviewers",
            label='Reviewer',
            label_msgid='conference_label_reviewer',
            i18n_domain='conference',
        ),
        required=1,
        multiValued=0,
        relationship='reviewer',
        allowed_types=('Reviewer',),
        read_permission="conference: View review comment"
    ),

    ReferenceField(
        name='article',
        widget=ReferenceBrowserWidget
        (
            startup_directory="../../Articles",
            label='Article',
            label_msgid='conference_label_article',
            i18n_domain='conference',
        ),
        required=1,
        multiValued=0,
        relationship='article',
        allowed_types=('Article',),
        read_permission="Manage properties"
    ),

),
)

##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

Review_schema = BaseSchema.copy() + \
    schema.copy()

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class Review(BaseContent):
    """
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseContent,'__implements__',()),)

    # This name appears in the 'add' box
    archetype_name = 'Review'

    meta_type = 'Review'
    portal_type = 'Review'
    allowed_content_types = []
    filter_content_types = 0
    global_allow = 0
    content_icon = 'product_icon.gif'
    immediate_view = 'base_view'
    default_view = 'view_review'
    suppl_views = ()
    typeDescription = "Review"
    typeDescMsgId = 'description_edit_review'


    actions =  (


       {'action': "string:${object_url}/edit_review",
        'category': "object",
        'id': 'Edit',
        'name': 'Edit',
        'permissions': ("View",),
        'condition': 'python:member.has_role(["Reviewer"],object)'
       },


       {'action': "string:${object_url}/base_edit",
        'category': "object",
        'id': 'edit',
        'name': 'Edit',
        'permissions': ("View",),
        'condition': 'python:member.has_role(["Manager","Owner"],object)'
       },


       {'action': "string:${object_url}/base_metadata",
        'category': "object",
        'id': 'metadata',
        'name': 'Properties',
        'permissions': ("View",),
        'condition': 'python:member.has_role(["Manager","Owner"],object)'
       },


    )

    _at_rename_after_creation = True

    schema = Review_schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header

    # Methods

    security.declarePublic('getArticleFile')
    def getArticleFile(self):
        """

        """

        art = self.getArticle()
        out = None
        if art:
            if art.getReviewversion():
                out = '''<a href="%s/at_download/reviewversion" class="Article">%s</a>
                      (<span class="state-%s">%s</span>)'''\
                      % (art.absolute_url(),self.translate(msgid='Article',domain='plone'),
                         self.portal_workflow.getInfoFor(art,'review_state'),self.translate(msgid=self.portal_workflow.getInfoFor(art,'review_state'),domain='plone'))
        return out


registerType(Review, PROJECTNAME)
# end of class Review

##code-section module-footer #fill in your manual code here
##/code-section module-footer



