# -*- coding: utf-8 -*-
#
# File: Reviewer.py
#
# Copyright (c) 2007 by []
# Generator: ArchGenXML Version 1.5.0
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """Josef Milota <milota@jcu.cz>"""
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.conference.config import *

# additional imports from tagged value 'import'
from Products.ATReferenceBrowserWidget.ATReferenceBrowserWidget import *

##code-section module-header #fill in your manual code here
##/code-section module-header

schema = Schema((

    StringField(
        name='id',
        widget=StringWidget(
            visible={'edit':'invisible', 'view':'invisible'},
            label='Id',
            label_msgid='conference_label_id',
            i18n_domain='conference',
        )
    ),

    ComputedField(
        name='title',
        widget=ComputedWidget(
            label='Title',
            label_msgid='conference_label_title',
            i18n_domain='conference',
        ),
        expression="context.getMyFullname()",
        accessor="Title",
        searchable=1
    ),

    ComputedField(
        name='reviews',
        widget=ComputedWidget(
            label='Reviews',
            label_msgid='conference_label_reviews',
            i18n_domain='conference',
        ),
        expression="context.getRevArticles()",
        read_permission="Manage portal content"
    ),

    FloatField(
        name='paid',
        default=0.0,
        widget=DecimalWidget(
            label='Paid',
            label_msgid='conference_label_paid',
            i18n_domain='conference',
        ),
        read_permission="Modify portal content",
        write_permission="conference: Edit content"
    ),

    DateTimeField(
        name='paiddate',
        widget=CalendarWidget(
            label='Paiddate',
            label_msgid='conference_label_paiddate',
            i18n_domain='conference',
        )
    ),

    ReferenceField(
        name='userid',
        widget=ReferenceBrowserWidget
        (
            startup_directory="/portal_memberdata",
            label='Userid',
            label_msgid='conference_label_userid',
            i18n_domain='conference',
        ),
        allowed_types=('ConfMember',),
        multiValued=0,
        relationship='userid',
        required=1
    ),

),
)

##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

Reviewer_schema = BaseSchema.copy() + \
    schema.copy()

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class Reviewer(BaseContent):
    """
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseContent,'__implements__',()),)

    # This name appears in the 'add' box
    archetype_name = 'Reviewer'

    meta_type = 'Reviewer'
    portal_type = 'Reviewer'
    allowed_content_types = []
    filter_content_types = 0
    global_allow = 0
    content_icon = 'user.gif'
    immediate_view = 'base_view'
    default_view = 'base_view'
    suppl_views = ()
    typeDescription = "Reviewer"
    typeDescMsgId = 'description_edit_reviewer'


    actions =  (


       {'action': "string:${object_url}/add_review_for_context",
        'category': "object",
        'id': 'create_review',
        'name': 'create_review',
        'permissions': ("View",),
        'condition': 'python:object.portal_membership.getAuthenticatedMember().has_permission("Modify portal content",object) and object.getConfObject().isReviewsManager()'
       },


    )

    _at_rename_after_creation = True

    schema = Reviewer_schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header

    # Methods

    security.declarePublic('getMyFullname')
    def getMyFullname(self):
        """

        """

        x = self.getUserid()
        if x:
            if x.getPerstitles():
                t = ', ' + x.getPerstitles()
            else:
                t = ''
            return x.getFullname() + t
        else:
            return 'Undefined User'

    security.declarePublic('Title')
    def Title(self):
        """

        """

        return self.getMyFullname()

    security.declarePublic('getRevArticles')
    def getRevArticles(self):
        """

        """

        out = '<ul>\n'
        revs = self.getBRefs(relationship='reviewer')
        for a in revs:
            f = a.getArticle()
            if f:
                out += '<li><a href="%s" class="Review">%s</a> - <span class="state-%s">%s</span>\
                        (<a href="%s" class="Article">%s</a> - <span class="state-%s">%s</span>)</li>\n'\
                      % (a.absolute_url(),a.title_or_id(),
                         self.portal_workflow.getInfoFor(a,'review_state'),self.translate(msgid=self.portal_workflow.getInfoFor(a,'review_state'),domain='plone'),
                         f.absolute_url(),f.title_or_id(),
                         self.portal_workflow.getInfoFor(f,'review_state'),self.translate(msgid=self.portal_workflow.getInfoFor(f,'review_state'),domain='plone'))
        out += '</ul>\n'
        return out

    security.declarePublic('getMyPaid')
    def getMyPaid(self):
        """

        """

        return self.getPaid()

    security.declarePublic('getMyPaiddate')
    def getMyPaiddate(self):
        """

        """

        return self.getPaiddate()


registerType(Reviewer, PROJECTNAME)
# end of class Reviewer

##code-section module-footer #fill in your manual code here
##/code-section module-footer



