# -*- coding: utf-8 -*-
#
# File: Reviewers.py
#
# Copyright (c) 2007 by []
# Generator: ArchGenXML Version 1.5.0
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """Josef Milota <milota@jcu.cz>"""
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.conference.LFolder import LFolder
from Products.conference.config import *

# additional imports from tagged value 'import'
from Products.CMFCore import CMFCorePermissions

##code-section module-header #fill in your manual code here
##/code-section module-header

schema = Schema((

    TextField(
        name='dataregistration',
        widget=RichWidget
        (
            visible={ 'edit' :'visible', 'view' : 'invisible' },
            label='Dataregistration',
            label_msgid='conference_label_dataregistration',
            i18n_domain='conference',
        )
    ),

    TextField(
        name='datapaid',
        widget=RichWidget
        (
            visible={ 'edit' :'visible', 'view' : 'invisible' },
            label='Datapaid',
            label_msgid='conference_label_datapaid',
            i18n_domain='conference',
        )
    ),

),
)

##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

Reviewers_schema = BaseBTreeFolderSchema.copy() + \
    getattr(LFolder, 'schema', Schema(())).copy() + \
    schema.copy()

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class Reviewers(LFolder, BaseBTreeFolder):
    """
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(LFolder,'__implements__',()),) + (getattr(BaseBTreeFolder,'__implements__',()),)

    # This name appears in the 'add' box
    archetype_name = 'Reviewers'

    meta_type = 'Reviewers'
    portal_type = 'Reviewers'
    allowed_content_types = ['Reviewer'] + list(getattr(LFolder, 'allowed_content_types', []))
    filter_content_types = 1
    global_allow = 0
    content_icon = 'group.gif'
    immediate_view = 'base_view'
    default_view = 'participants_view'
    suppl_views = ('folder_listing',)
    typeDescription = "Reviewers"
    typeDescMsgId = 'description_edit_reviewers'


    actions =  (


       {'action': "string:${object_url}/participants_view",
        'category': "object",
        'id': 'view',
        'name': 'View',
        'permissions': ("View",),
        'condition': 'python:1'
       },


       {'action': "string:${object_url}/import_export",
        'category': "object",
        'id': 'import_export',
        'name': 'import_export',
        'permissions': ("Modify portal content",),
        'condition': 'python:1'
       },


       {'action': "string:${object_url}/reports_conferee_form",
        'category': "object",
        'id': 'Reports',
        'name': 'Reports',
        'permissions': ("Modify portal content",),
        'condition': 'python:1'
       },


       {'action': "string:${object_url}/sendto_conferee_form",
        'category': "object",
        'id': 'sendto',
        'name': 'sendto',
        'permissions': ("Modify portal content",),
        'condition': 'python:1'
       },


    )

    _at_rename_after_creation = True

    schema = Reviewers_schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header

    # Methods


registerType(Reviewers, PROJECTNAME)
# end of class Reviewers

##code-section module-footer #fill in your manual code here
##/code-section module-footer



