# -*- coding: utf-8 -*-
#
# File: Reviews.py
#
# Copyright (c) 2007 by []
# Generator: ArchGenXML Version 1.5.0
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """Josef Milota <milota@jcu.cz>"""
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.conference.LFolder import LFolder
from Products.conference.config import *

# additional imports from tagged value 'import'
from Products.CMFCore import CMFCorePermissions

##code-section module-header #fill in your manual code here
##/code-section module-header

schema = Schema((

    TextField(
        name='datareviews',
        widget=RichWidget
        (
            visible={ 'edit' :'visible', 'view' : 'invisible' },
            label='Datareviews',
            label_msgid='conference_label_datareviews',
            i18n_domain='conference',
        )
    ),

),
)

##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

Reviews_schema = BaseBTreeFolderSchema.copy() + \
    getattr(LFolder, 'schema', Schema(())).copy() + \
    schema.copy()

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class Reviews(LFolder, BaseBTreeFolder):
    """
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(LFolder,'__implements__',()),) + (getattr(BaseBTreeFolder,'__implements__',()),)

    # This name appears in the 'add' box
    archetype_name = 'Reviews'

    meta_type = 'Reviews'
    portal_type = 'Reviews'
    allowed_content_types = ['Review'] + list(getattr(LFolder, 'allowed_content_types', []))
    filter_content_types = 1
    global_allow = 0
    content_icon = 'confirm_icon.gif'
    immediate_view = 'base_view'
    default_view = 'folder_listing'
    suppl_views = ('folder_listing',)
    typeDescription = "Reviews"
    typeDescMsgId = 'description_edit_reviews'


    actions =  (


       {'action': "string:${object_url}/import_export",
        'category': "object",
        'id': 'import_export',
        'name': 'import_export',
        'permissions': ("Modify portal content",),
        'condition': 'python:1'
       },


    )

    _at_rename_after_creation = True

    schema = Reviews_schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header

    # Methods

    security.declareProtected("Modify portal content", 'batchreviewsstart')
    def batchreviewsstart(self):
        """

        """

        """
        Batch reviews setting - data should be in the form:
            review_title;reviewer_username;article_id
        Lines with leading character '#' will be ignored.
        """

        import time
        out = ''
        conf = self.getConfObject()
        type_name = self.allowed_content_types[0]
        d1 = str.split(self.getDatareviews().replace('\r',''),"\n"); n = 0; k = 0
        d = []
        for x in d1:
            if len(x)>0:
                if not x.lstrip()[0] in ['#']:
                    d.append(x)
        reviewers = {}
        for r in conf.objectValues(['Reviewers']):
            for x in r.objectValues(['Reviewer']):
                if x.getUserid():
                    reviewers[x.getUserid().getId()] = x
        articles = {}
        for r in conf.objectValues(['Articles']):
            for x in r.objectValues(['Article']):
                articles[x.getId()] = x
        for i in d:
            x = str.split(i,";")
            if (len(x)>=3):
              n = n + 1
              if x[1] in reviewers.keys() and x[2] in articles.keys():
                      newid = self.generateUniqueId(type_name)
                      self.invokeFactory(id=newid,type_name=type_name,title=x[0],reviewer=reviewers[x[1]].UID(),article=articles[x[2]].UID())
                      self.portal_membership.setLocalRoles(self[newid],[x[1]],'Owner')
                      out += 'Created new review with title="%s", reviewer_username="%s" (%s), article_id="%s" (%s)\n' % (x[0],x[1],reviewers[x[1]].getUserid().getFullname(),x[2],articles[x[2]].Title())
                      k = k + 1
              else:
                  if not x[1] in reviewers.keys():
                      out += 'NO REVIEWER with reviewer_username="%s"\n' % x[1]
                  if not x[2] in articles.keys():
                      out += 'NO ARTICLE with article_id="%s"\n' % x[2]
        out += 'Processed items: %s, created reviews: %s, BAD LINES: %s.\n' % (n,k,n-k)
        return out

    security.declareProtected("Modify portal content", 'exportReviews')
    def exportReviews(self):
        """

        """

        userobjs = [x for x in self.objectValues(['Review']) if (x.getReviewer() and x.getArticle())]
        out = '# DATA FOR BATCH REVIEW REGISTRATION - structure:\n'
        out += '#    review_title;reviewer_username;article_id;review_state;reviewer_fullname;article_title\n'
        for x in userobjs:
            user = x.getReviewer().getUserid()
            out += '%s;%s;%s;%s;%s;%s\n' % (x.title_or_id(),user.getId(),x.getArticle().getId(),self.portal_workflow.getInfoFor(x, 'review_state', ''),user.getFullname(),x.getArticle().Title())
        return out


registerType(Reviews, PROJECTNAME)
# end of class Reviews

##code-section module-footer #fill in your manual code here
##/code-section module-footer



