## Controller Python Script "add_review_for_context"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind state=state
##bind subpath=traverse_subpath
##parameters=
##title=Add Review for current context.
##

conf = context.getConfObject()

utool = context.portal_url
path = utool.getPortalPath() + '/' + utool.getRelativeUrl(conf)
norm = context.plone_utils.normalizeString
request = context.REQUEST

reviews = [x.getObject() for x in context.portal_catalog.searchResults(portal_type='Reviews',path=path)]
if reviews:
    reviews = reviews[0]
else:
    return state.set(status='failure', portal_status_message='No reviews folder!')

id=context.generateUniqueId('Review')
newreview = False

if context.portal_type == 'Article':
    newtitle = context.translate(msgid='Review',domain='plone') + ': ' + context.Title()
    reviews.invokeFactory(id=id,type_name='Review',title=newtitle)
    review = reviews[id]
    review.setArticle(context.UID())
    newreview = True

if context.portal_type == 'Reviewer':
    newtitle = context.translate(msgid='Review',domain='plone') + ': ' + context.Title() + ' - ' + id
    reviews.invokeFactory(id=id,type_name='Review',title=newtitle)
    review = reviews[id]
    review.setReviewer(context.UID())
    newreview = True

if newreview:
    dest = '%s/%s/%s/edit' % (conf.absolute_url(),reviews.getId(),review.getId())
    return request.RESPONSE.redirect(dest)

return state.set(status='failure', portal_status_message='No review created!')
