## Controller Python Script "email_notif_send"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind state=state
##bind subpath=traverse_subpath
##parameters=send_to_address='',object=None,conf=None
##title=Send email notification
##

if object == None:
    return state.set(status='failure', portal_status_message='No object for notification.')
    
REQUEST=context.REQUEST

from Products.CMFPlone.utils import transaction_note
from Products.CMFPlone.PloneTool import AllowSendto
from Products.CMFCore.utils import getToolByName
from ZODB.POSException import ConflictError

plone_utils = getToolByName(context, 'plone_utils')
mtool = getToolByName(context, 'portal_membership')
wtool = getToolByName(context, 'portal_workflow')
site_properties = getToolByName(context, 'portal_properties').site_properties
pretty_title_or_id = plone_utils.pretty_title_or_id
empty_title = plone_utils.getEmptyTitle()
host = context.MailHost

if not mtool.checkPermission(AllowSendto, context):
    return state.set(
            status='failure',
            portal_status_message='You are not allowed to send this e-mail.')

if not conf:
    conf = context.getConfObject()
if conf.getConf_manager_email():
    send_from_address = conf.getConf_manager_email()
else:
    member = mtool.getAuthenticatedMember()
    send_from_address = REQUEST.get('send_from_address', member.getProperty('email',''))             
conferencetitle = conf.pretty_title_or_id()
conferenceurl = conf.absolute_url()
itemtitle = object.pretty_title_or_id()
itemurl = object.absolute_url()
itemname = object.portal_type
itemstatus = wtool.getInfoFor(object, 'review_state')
variables = {'conferencetitle':conferencetitle,
             'conferenceurl':conferenceurl,
             'itemtitle':itemtitle,
             'itemurl':itemurl,
             'itemname':itemname,
             'itemstatus':itemstatus
            }    
subject = conferencetitle + ': ' + context.translate(msgid='email_notif_subject',domain='plone')
msg = context.email_notif_template(context,**variables)
charset = context.plone_utils.getSiteEncoding()
subtype = 'html'

try:
    result = host.secureSend(msg, send_to_address, send_from_address, subject=subject, subtype=subtype, charset=charset)
except ConflictError:
    raise
except: #XXX Too many things could possibly go wrong. So we catch all.
    exception = context.plone_utils.exceptionString()
    message = context.translate("Unable to send mail: ${exception}",
                                {'exception': exception})
    return state.set(status='failure', portal_status_message=message)

tmsg='Sent mail from %s to %s' % (send_from_address, send_to_address)
transaction_note(tmsg)

return state.set(portal_status_message='Mail sent.')
