## Controller Python Script "sendto_conferee"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind state=state
##bind subpath=traverse_subpath
##parameters=
##title=Send information to conferee or reviewer
##
REQUEST=context.REQUEST

from Products.CMFPlone.utils import transaction_note
from Products.CMFPlone.PloneTool import AllowSendto
from Products.CMFCore.utils import getToolByName
from ZODB.POSException import ConflictError

plone_utils = getToolByName(context, 'plone_utils')
mtool = getToolByName(context, 'portal_membership')
site_properties = getToolByName(context, 'portal_properties').site_properties
pretty_title_or_id = plone_utils.pretty_title_or_id
empty_title = plone_utils.getEmptyTitle()
host = context.MailHost

if not mtool.checkPermission(AllowSendto, context):
    return state.set(
            status='failure',
            portal_status_message='You are not allowed to send this e-mail.')

conferee_list = [x.split(',') for x in REQUEST.get('conferee_list',[])]
send_from_address = REQUEST.send_from_address             

if 'send_pers_info' in REQUEST.keys():
    send_pers_info = True
else:
    send_pers_info = False

if 'send_tax_info' in REQUEST.keys():
    send_tax_info = True
else:
    send_tax_info = False

subject = REQUEST.get('subject','[No Subject]')
msg = REQUEST.get('comment','')
charset = context.plone_utils.getSiteEncoding()
subtype = 'html'

for c in conferee_list:
    send_to_address = c[1]
    variables = {'confereeid':c[0].split('/')[-1],'userid':c[2]}
    out = ''
    if send_pers_info:
        msg_pers_info = context.pers_info_template(context, **variables)
    else:
        msg_pers_info = ''
    if send_tax_info:
        msg_tax_info = context.tax_info_template(context, **variables)
    else:
        msg_tax_info = ''
    message = '<hr />\n'.join([x for x in [msg, msg_pers_info, msg_tax_info] if x])
    out += message

    try:
        result = host.secureSend(message, send_to_address, send_from_address, subject=subject, subtype=subtype, charset=charset)
    except ConflictError:
        raise
    except: #XXX Too many things could possibly go wrong. So we catch all.
        exception = context.plone_utils.exceptionString()
        message = context.translate("Unable to send mail: ${exception}",
                                    {'exception': exception})
        return state.set(status='failure', portal_status_message=message)

    tmsg='Sent mail from %s to %s' % (send_from_address, send_to_address)
    transaction_note(tmsg)

return state.set(portal_status_message='Mail sent.')
